package com.glxp.udi.admin.controller.auth;


import com.github.pagehelper.PageInfo;
import com.glxp.udi.admin.entity.auth.CustomerContactEntity;
import com.glxp.udi.admin.req.auth.CustomerContactFilterRequest;
import com.glxp.udi.admin.req.inout.DeleteRequest;
import com.glxp.udi.admin.res.PageSimpleResponse;
import com.glxp.udi.admin.service.auth.impl.CustomerContactService;
import com.glxp.udi.common.res.BaseResponse;
import com.glxp.udi.common.util.ResultVOUtils;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import java.util.List;

@RestController
@Slf4j
public class CustomerContactController {

    @Resource
    private CustomerContactService customerContactService;


    @GetMapping("salewarehouse/customerContact/list")
    public BaseResponse filterList(CustomerContactFilterRequest customerFilterRequest) {
        List<CustomerContactEntity> customerContactEntityList = customerContactService.filterCustomerContact(customerFilterRequest);
        PageInfo<CustomerContactEntity> pageInfo;
        pageInfo = new PageInfo<>(customerContactEntityList);
        PageSimpleResponse<CustomerContactEntity> pageSimpleResponse = new PageSimpleResponse<>();
        pageSimpleResponse.setTotal(pageInfo.getTotal());
        pageSimpleResponse.setList(customerContactEntityList);
        return ResultVOUtils.success(pageSimpleResponse);
    }


    @GetMapping("salewarehouse/customerContact/add")
    public BaseResponse addContact(CustomerContactEntity customerContactEntity) {

        boolean b = customerContactService.insertCustomerContact(customerContactEntity);
        if (b)
            return ResultVOUtils.success("添加成功");
        else {
            return ResultVOUtils.error(500, "添加失败");
        }

    }

    @GetMapping("salewarehouse/customerContact/delete")
    public BaseResponse deleteContact(DeleteRequest deleteRequest) {
        boolean b = customerContactService.deleteById(Long.parseLong(deleteRequest.getId()));
        if (b)
            return ResultVOUtils.success("删除成功");
        else {
            return ResultVOUtils.error(500, "删除失败");
        }
    }

}
