package com.glxp.udi.admin.controller.device;

import com.alibaba.fastjson.JSONObject;
import com.glxp.udi.admin.entity.info.CompanyEntity;
import com.glxp.udi.admin.entity.publish.PostIdentifyEntity;
import com.glxp.udi.admin.entity.udid.*;
import com.glxp.udi.admin.req.publish.PostIdentifyKeyRequest;
import com.glxp.udi.admin.req.udid.DeviceRequest;
import com.glxp.udi.admin.req.udid.DownloadDiRequest;
import com.glxp.udi.admin.req.udid.DownloadHistoryRequest;
import com.glxp.udi.admin.req.udid.TokenRequest;
import com.glxp.udi.admin.res.publish.PostSaveResponse;
import com.glxp.udi.admin.res.publish.PostSubmitResponse;
import com.glxp.udi.admin.res.udid.DataSetBean;
import com.glxp.udi.admin.res.udid.MedicalHistoryResonse;
import com.glxp.udi.admin.res.udid.MedicalResonse;
import com.glxp.udi.admin.res.udid.MedicalSingleResponse;
import com.glxp.udi.admin.service.inout.DeviceService;
import com.glxp.udi.admin.util.HttpClient;
import com.glxp.udi.admin.util.WarehousBeanUtils;
import com.google.gson.Gson;

import java.util.ArrayList;
import java.util.List;
import java.util.UUID;

public class DownloadDeviceHelper {


    CompanyEntity companyEntity;
    String url = "";
    String appId;
    String appSecret;

//    public DownloadDeviceHelper(CompanyService companyService) {
//        long customerId = 110;
//        companyEntity = companyService.findCompany(customerId);
//        if (companyEntity != null && companyEntity.getClasses() != null) {
//            if (companyEntity.getClasses().equals("1")) {
//                url = "company/identifier/get";
//            } else {
//                url = "sharing/get";
//            }
//            appId = companyEntity.getAppId();
//            appSecret = companyEntity.getAppSecret();
//        }
//    }

    public DownloadDeviceHelper(CompanyEntity companyEntity) {

        this.companyEntity = companyEntity;
        appId = companyEntity.getAppId();
        appSecret = companyEntity.getAppSecret();
    }


    //获取token
    public TokenEntity getToken() {
        TokenRequest tokenRequest = new TokenRequest();

        tokenRequest.setAppId(appId);
        tokenRequest.setAppSecret(appSecret);
        String response = HttpClient.post("token/get", tokenRequest);
        TokenEntity tokenEntity = (TokenEntity) JSONObject.parseObject(response, TokenEntity.class);
        System.out.println(tokenEntity.getAccessToken());
        return tokenEntity;
    }

    //产品数据申报
    public int getTotal(String token) {
        DeviceRequest deviceRequest = new DeviceRequest();
        deviceRequest.setCurrentPageNumber("1");
        deviceRequest.setRequestType("3");
        deviceRequest.setAccessToken(token);
        String response = HttpClient.post("company/identifier/get", deviceRequest);
        MedicalResonse medicalResonse = (MedicalResonse) JSONObject.parseObject(response, MedicalResonse.class);
        return medicalResonse.getTotalPageCount();
    }

    //下载流通企业
    public int downloadDevices(DeviceService deviceService, DeviceRequest deviceRequest) {
        String response = HttpClient.post("sharing/get", deviceRequest);
        int result = -1;
        List<DataSetBean> dataSetBeanList;
        if (url.equals("sharing/get")) {
            MedicalResonse medicalResonse = (MedicalResonse) JSONObject.parseObject(response, MedicalResonse.class);
            result = medicalResonse.getReturnCode();
            dataSetBeanList = medicalResonse.getDataSet();
        } else {
            MedicalHistoryResonse medicalResonse = (MedicalHistoryResonse) JSONObject.parseObject(response, MedicalHistoryResonse.class);
            result = medicalResonse.getReturnCode();
            dataSetBeanList = medicalResonse.getDataList();
        }


        if (dataSetBeanList != null && dataSetBeanList.size() > 0) {
            for (int i = 0; i < dataSetBeanList.size(); i++) {
                DataSetBean dataSetBean = dataSetBeanList.get(i);
                Device device = WarehousBeanUtils.responseToDevice(dataSetBean);
                if (deviceService.selectisSame(device.getDevicerecordkey(), device.getVersionnumber()) != null) {
                    return 1;
                }
                if (device.getBssjzt() != null && device.getBssjzt().equals("草稿")) {
                    //草稿数据忽略
                } else {
                    String uuid = getUUId();
                    device.setUuid(uuid);

                    String versionNum = device.getVersionnumber();
                    //如果版本号大于1，说明是新增，则更新历史记录
                    if (versionNum != null && Integer.parseInt(versionNum) > 1) {

                        deviceService.deleteHistory(device.getDevicerecordkey());
                        DownloadHistoryRequest deviceHistoryRequest = new DownloadHistoryRequest();
                        deviceHistoryRequest.setAccessToken(deviceRequest.getAccessToken());
                        deviceHistoryRequest.setCurrentPageNumber("1");
                        List<DownloadHistoryRequest.DataSetBean> dataSetBeans = new ArrayList<>();
                        DownloadHistoryRequest.DataSetBean keys = new DownloadHistoryRequest.DataSetBean();
                        keys.setDeviceRecordKey(device.getDevicerecordkey());
                        dataSetBeans.add(keys);
                        deviceHistoryRequest.setDataSet(dataSetBeans);
                        downloadHistory("",deviceHistoryRequest, deviceService);
                    }

                    deviceService.insertDevice(device);
                    List<DataSetBean.DeviceClinicalBean> deviceclinicals = dataSetBean.getDeviceClinical();
                    List<Deviceclinical> deviceclinicalList = new ArrayList<>();
                    if (deviceclinicalList != null && deviceclinicalList.size() > 0) {
                        for (DataSetBean.DeviceClinicalBean deviceClinicalBean : deviceclinicals) {
                            if (deviceClinicalBean != null) {
                                Deviceclinical deviceclinical = WarehousBeanUtils.responseToDeviceclinical(deviceClinicalBean);
                                deviceclinical.setDevicerecordkey(device.getDevicerecordkey());
                                deviceclinical.setUuid(uuid);
                                deviceclinicalList.add(deviceclinical);
                            }

                        }
                        deviceService.insertDeviceClinical(deviceclinicalList);

                    }
                    List<DataSetBean.DevicePackageBean> devicePackageBeans = dataSetBean.getDevicePackage();
                    if (devicePackageBeans != null && devicePackageBeans.size() > 0) {
                        List<Devicepackage> devicepackageList = new ArrayList<>();
                        for (DataSetBean.DevicePackageBean devicePackageBean : devicePackageBeans) {
                            Devicepackage devicepackage = WarehousBeanUtils.responseToDevicepackage(devicePackageBean);
                            devicepackage.setDevicerecordkey(device.getDevicerecordkey());
                            devicepackage.setUuid(uuid);
                            devicepackageList.add(devicepackage);
                        }
                        deviceService.insertDevicepackage(devicepackageList);
                    }


                    List<DataSetBean.DeviceStorageBean> deviceStorageBeans = dataSetBean.getDeviceStorage();
                    if (deviceStorageBeans != null && deviceStorageBeans.size() > 0) {
                        List<Devicestorage> devicestorageList = new ArrayList<>();
                        for (DataSetBean.DeviceStorageBean deviceStorageBean : deviceStorageBeans) {
                            Devicestorage devicestorage = WarehousBeanUtils.responseToDevicestorage(deviceStorageBean);
                            devicestorage.setDevicerecordkey(device.getDevicerecordkey());
                            devicestorage.setUuid(uuid);
                            devicestorageList.add(devicestorage);
                        }
                        deviceService.insertDevicestorage(devicestorageList);
                    }
                    List<DataSetBean.ContactListBean> contactListBeans = dataSetBean.getContactList();
                    if (contactListBeans != null && contactListBeans.size() > 0) {
                        List<Contactlist> contactlistList = new ArrayList<>();
                        for (DataSetBean.ContactListBean contactListBean : contactListBeans) {
                            Contactlist contactlist = WarehousBeanUtils.responseToContactlist(contactListBean);
                            contactlist.setDevicerecordkey(device.getDevicerecordkey());
                            contactlist.setUuid(uuid);
                            contactlistList.add(contactlist);
                        }
                        deviceService.insertContactlist(contactlistList);
                    }
                }

            }
        }

        return result;
    }

    //下载生产企业
    public int downloadProduct(String customerId,DeviceService deviceService, DeviceRequest deviceRequest) {
        String response = HttpClient.post("company/identifier/get", deviceRequest);
        MedicalHistoryResonse medicalResonse = (MedicalHistoryResonse) JSONObject.parseObject(response, MedicalHistoryResonse.class);
        if (medicalResonse.getReturnCode() == 1) {
            List<DataSetBean> dataSetBeanList = medicalResonse.getDataList();
            if (dataSetBeanList != null && dataSetBeanList.size() > 0) {
                for (int i = 0; i < dataSetBeanList.size(); i++) {
                    DataSetBean dataSetBean = dataSetBeanList.get(i);
                    Device device = WarehousBeanUtils.responseToDevice(dataSetBean);
                    device.setCustomerId(customerId);
                    if (deviceService.selectisSame(device.getDevicerecordkey(), device.getVersionnumber()) != null) {
//                        return -1;
                    } else if (device.getBssjzt() != null && device.getBssjzt().equals("草稿")) {
                        //草稿数据忽略
                    } else {
                        String uuid = getUUId();
                        device.setUuid(uuid);

                        String versionNum = device.getVersionnumber();
                        //如果版本号大于1，说明是新增，则更新历史记录
                        if (versionNum != null && Integer.parseInt(versionNum) > 1) {

                            deviceService.deleteHistory(device.getDevicerecordkey());
                            DownloadHistoryRequest deviceHistoryRequest = new DownloadHistoryRequest();
                            deviceHistoryRequest.setAccessToken(deviceRequest.getAccessToken());
                            deviceHistoryRequest.setCurrentPageNumber("1");
                            List<DownloadHistoryRequest.DataSetBean> dataSetBeans = new ArrayList<>();
                            DownloadHistoryRequest.DataSetBean keys = new DownloadHistoryRequest.DataSetBean();
                            keys.setDeviceRecordKey(device.getDevicerecordkey());
                            dataSetBeans.add(keys);
                            deviceHistoryRequest.setDataSet(dataSetBeans);
                            downloadHistory(customerId,deviceHistoryRequest, deviceService);
                        }

                        deviceService.insertDevice(device);
                        List<DataSetBean.DeviceClinicalBean> deviceclinicals = dataSetBean.getDeviceClinical();
                        if (deviceclinicals != null && deviceclinicals.size() > 0) {
                            List<Deviceclinical> deviceclinicalList = new ArrayList<>();
                            for (DataSetBean.DeviceClinicalBean deviceClinicalBean : deviceclinicals) {
                                if (deviceClinicalBean != null) {
                                    Deviceclinical deviceclinical = WarehousBeanUtils.responseToDeviceclinical(deviceClinicalBean);
                                    deviceclinical.setDevicerecordkey(device.getDevicerecordkey());
                                    deviceclinical.setUuid(uuid);
                                    deviceclinicalList.add(deviceclinical);
                                }
                            }
                            deviceService.insertDeviceClinical(deviceclinicalList);
                        }


                        List<DataSetBean.DevicePackageBean> devicePackageBeans = dataSetBean.getDevicePackage();
                        if (devicePackageBeans != null && devicePackageBeans.size() > 0) {
                            List<Devicepackage> devicepackageList = new ArrayList<>();
                            for (DataSetBean.DevicePackageBean devicePackageBean : devicePackageBeans) {
                                Devicepackage devicepackage = WarehousBeanUtils.responseToDevicepackage(devicePackageBean);
                                devicepackage.setDevicerecordkey(device.getDevicerecordkey());
                                devicepackage.setUuid(uuid);
                                devicepackageList.add(devicepackage);
                            }
                            deviceService.insertDevicepackage(devicepackageList);
                        }


                        List<DataSetBean.DeviceStorageBean> deviceStorageBeans = dataSetBean.getDeviceStorage();
                        if (deviceStorageBeans != null && deviceStorageBeans.size() > 0) {
                            List<Devicestorage> devicestorageList = new ArrayList<>();
                            for (DataSetBean.DeviceStorageBean deviceStorageBean : deviceStorageBeans) {
                                Devicestorage devicestorage = WarehousBeanUtils.responseToDevicestorage(deviceStorageBean);
                                devicestorage.setDevicerecordkey(device.getDevicerecordkey());
                                devicestorage.setUuid(uuid);
                                devicestorageList.add(devicestorage);
                            }
                            deviceService.insertDevicestorage(devicestorageList);
                        }


                        List<DataSetBean.ContactListBean> contactListBeans = dataSetBean.getContactList();
                        if (contactListBeans != null && contactListBeans.size() > 0) {
                            List<Contactlist> contactlistList = new ArrayList<>();
                            for (DataSetBean.ContactListBean contactListBean : contactListBeans) {
                                Contactlist contactlist = WarehousBeanUtils.responseToContactlist(contactListBean);
                                contactlist.setDevicerecordkey(device.getDevicerecordkey());
                                contactlist.setUuid(uuid);
                                contactlistList.add(contactlist);
                            }
                            deviceService.insertContactlist(contactlistList);
                        }

                    }

                }
            }
        } else {
            return -1;
        }
        return 1;
    }

    //下载历史记录
    public int downloadHistory(String customerId,DownloadHistoryRequest deviceHistoryRequest, DeviceService deviceService) {
        String response = HttpClient.post("sharing/history/get", deviceHistoryRequest);
        MedicalHistoryResonse medicalResonse = (MedicalHistoryResonse) JSONObject.parseObject(response, MedicalHistoryResonse.class);
        if (medicalResonse.getReturnCode() == 1) {
            List<DataSetBean> dataSetBeanList = medicalResonse.getDataList();
            if (dataSetBeanList != null && dataSetBeanList.size() > 0) {
                for (int i = 0; i < dataSetBeanList.size(); i++) {
                    DataSetBean dataSetBean = dataSetBeanList.get(i);
                    Device device = WarehousBeanUtils.responseToDevice(dataSetBean);
                    String uuid = getUUId();
                    device.setUuid(uuid);
                    device.setCustomerId(customerId);
                    deviceService.insertDevice(device);

                    List<DataSetBean.DeviceClinicalBean> deviceclinicals = dataSetBean.getDeviceClinical();
                    List<Deviceclinical> deviceclinicalList = new ArrayList<>();
                    for (DataSetBean.DeviceClinicalBean deviceClinicalBean : deviceclinicals) {
                        if (deviceClinicalBean != null) {
                            Deviceclinical deviceclinical = WarehousBeanUtils.responseToDeviceclinical(deviceClinicalBean);
                            deviceclinical.setDevicerecordkey(device.getDevicerecordkey());
                            deviceclinical.setUuid(uuid);
                            deviceclinicalList.add(deviceclinical);
                        }

                    }
                    deviceService.insertDeviceClinical(deviceclinicalList);

                    List<DataSetBean.DevicePackageBean> devicePackageBeans = dataSetBean.getDevicePackage();
                    List<Devicepackage> devicepackageList = new ArrayList<>();
                    for (DataSetBean.DevicePackageBean devicePackageBean : devicePackageBeans) {
                        Devicepackage devicepackage = WarehousBeanUtils.responseToDevicepackage(devicePackageBean);
                        devicepackage.setDevicerecordkey(device.getDevicerecordkey());
                        devicepackage.setUuid(uuid);
                        devicepackageList.add(devicepackage);
                    }
                    deviceService.insertDevicepackage(devicepackageList);

                    List<DataSetBean.DeviceStorageBean> deviceStorageBeans = dataSetBean.getDeviceStorage();
                    List<Devicestorage> devicestorageList = new ArrayList<>();
                    for (DataSetBean.DeviceStorageBean deviceStorageBean : deviceStorageBeans) {
                        Devicestorage devicestorage = WarehousBeanUtils.responseToDevicestorage(deviceStorageBean);
                        devicestorage.setDevicerecordkey(device.getDevicerecordkey());
                        devicestorage.setUuid(uuid);
                        devicestorageList.add(devicestorage);
                    }
                    deviceService.insertDevicestorage(devicestorageList);

                    List<DataSetBean.ContactListBean> contactListBeans = dataSetBean.getContactList();
                    List<Contactlist> contactlistList = new ArrayList<>();
                    for (DataSetBean.ContactListBean contactListBean : contactListBeans) {
                        Contactlist contactlist = WarehousBeanUtils.responseToContactlist(contactListBean);
                        contactlist.setDevicerecordkey(device.getDevicerecordkey());
                        contactlist.setUuid(uuid);
                        contactlistList.add(contactlist);
                    }
                    deviceService.insertContactlist(contactlistList);
                }
            }
        } else {
            return -1;
        }
        return 1;
    }

    //单挑下载
    public int downloadBydi(String customerId,DownloadDiRequest downloadDiRequest, DeviceService deviceService) {
        String response = HttpClient.post("sharing/single", downloadDiRequest);
        MedicalSingleResponse medicalResonse = (MedicalSingleResponse) JSONObject.parseObject(response, MedicalSingleResponse.class);
        if (medicalResonse.getReturnCode() == 1) {
            List<DataSetBean> dataSetBeanList = medicalResonse.getDataSet();
            if (dataSetBeanList != null && dataSetBeanList.size() > 0) {
                for (int i = 0; i < dataSetBeanList.size(); i++) {
                    DataSetBean dataSetBean = dataSetBeanList.get(i);
                    Device device = WarehousBeanUtils.responseToDevice(dataSetBean);
                    String uuid = getUUId();
                    device.setUuid(uuid);
                    if (deviceService.selectisSame(device.getDevicerecordkey(), device.getVersionnumber()) != null) {
                        return -1;
                    }
                    device.setCustomerId(customerId);
                    deviceService.insertDevice(device);
                    List<DataSetBean.DeviceClinicalBean> deviceclinicals = dataSetBean.getDeviceClinical();
                    List<Deviceclinical> deviceclinicalList = new ArrayList<>();
                    for (DataSetBean.DeviceClinicalBean deviceClinicalBean : deviceclinicals) {
                        if (deviceClinicalBean != null) {
                            Deviceclinical deviceclinical = WarehousBeanUtils.responseToDeviceclinical(deviceClinicalBean);
                            deviceclinical.setDevicerecordkey(device.getDevicerecordkey());
                            deviceclinical.setUuid(uuid);
                            deviceclinicalList.add(deviceclinical);
                        }
                    }
                    deviceService.insertDeviceClinical(deviceclinicalList);

                    List<DataSetBean.DevicePackageBean> devicePackageBeans = dataSetBean.getDevicePackage();
                    List<Devicepackage> devicepackageList = new ArrayList<>();
                    for (DataSetBean.DevicePackageBean devicePackageBean : devicePackageBeans) {
                        Devicepackage devicepackage = WarehousBeanUtils.responseToDevicepackage(devicePackageBean);
                        devicepackage.setDevicerecordkey(device.getDevicerecordkey());
                        devicepackage.setUuid(uuid);
                        devicepackageList.add(devicepackage);
                    }
                    deviceService.insertDevicepackage(devicepackageList);

                    List<DataSetBean.DeviceStorageBean> deviceStorageBeans = dataSetBean.getDeviceStorage();
                    List<Devicestorage> devicestorageList = new ArrayList<>();
                    for (DataSetBean.DeviceStorageBean deviceStorageBean : deviceStorageBeans) {
                        Devicestorage devicestorage = WarehousBeanUtils.responseToDevicestorage(deviceStorageBean);
                        devicestorage.setDevicerecordkey(device.getDevicerecordkey());
                        devicestorage.setUuid(uuid);
                        devicestorageList.add(devicestorage);
                    }
                    deviceService.insertDevicestorage(devicestorageList);

                    List<DataSetBean.ContactListBean> contactListBeans = dataSetBean.getContactList();
                    List<Contactlist> contactlistList = new ArrayList<>();
                    for (DataSetBean.ContactListBean contactListBean : contactListBeans) {
                        Contactlist contactlist = WarehousBeanUtils.responseToContactlist(contactListBean);
                        contactlist.setDevicerecordkey(device.getDevicerecordkey());
                        contactlist.setUuid(uuid);
                        contactlistList.add(contactlist);
                    }
                    deviceService.insertContactlist(contactlistList);
                }

            }
        } else {
            return -1;
        }
        return 1;
    }

    //草稿上传
    public PostSaveResponse postIdentify(PostIdentifyEntity postIdentifyEntity) {

        //将java对象转换为json对象
        String params = new Gson().toJson(postIdentifyEntity);//JSONObject.toJSONString(postIdentifyEntity,false);

        String response = HttpClient.post("company/identifier/save", params);
        PostSaveResponse postSaveResponse = (PostSaveResponse) JSONObject.parseObject(response, PostSaveResponse.class);
        return postSaveResponse;
    }

    //提交标识
    public PostSubmitResponse postIdentifyKey(PostIdentifyKeyRequest postIdentifyKeyRequest) {
        String params = new Gson().toJson(postIdentifyKeyRequest);
        String response = HttpClient.post("company/identifier/submit", params);
        PostSubmitResponse postSaveResponse = (PostSubmitResponse) JSONObject.parseObject(response, PostSubmitResponse.class);
        return postSaveResponse;
    }

    private String getUUId() {
        UUID uuid = UUID.randomUUID();
        return uuid.toString().replace("-", "");
    }

}
