package com.glxp.udi.admin.controller.info;

import com.glxp.udi.admin.entity.auth.CustomerContactEntity;
import com.glxp.udi.admin.entity.info.CompanyEntity;
import com.glxp.udi.admin.req.info.CompanyRequest;
import com.glxp.udi.admin.service.auth.impl.CustomerContactService;
import com.glxp.udi.admin.service.info.CompanyService;
import com.glxp.udi.common.res.BaseResponse;
import com.glxp.udi.common.util.ResultVOUtils;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;

@RestController
public class CompanyController {

    @Resource
    private CompanyService companyService;
    @Resource
    CustomerContactService customerContactService;

    @GetMapping("/warehouse/info/company")
    public BaseResponse getCompanyInfo(CompanyRequest companyRequest) {
        CompanyEntity companyEntity = companyService.findCompany(companyRequest.getCustomerId());
        if (companyEntity != null) {
            return ResultVOUtils.success(companyEntity);
        }
        return ResultVOUtils.error(500, "企业信息为空");
    }

    @PostMapping("/warehouse/info/modifyCompany")
    public BaseResponse modifyCompany(@RequestBody CompanyEntity companyEntity) {

        boolean b = companyService.modifyCompany(companyEntity);
        CustomerContactEntity customerContactEntity = new CustomerContactEntity();
        customerContactEntity.setTel(companyEntity.getTel());
        customerContactEntity.setMobile(companyEntity.getMobile());
        customerContactEntity.setEmail(companyEntity.getEmail());
        customerContactEntity.setContacts(companyEntity.getContacts());
        customerContactEntity.setCustomerId(companyEntity.getCustomerId());
        customerContactService.updateCustomerContact(customerContactEntity);

        return ResultVOUtils.success("修改成功");
    }
}
