package com.glxp.udi.admin.controller.info;

import com.glxp.udi.admin.entity.info.SetupEntity;
import com.glxp.udi.admin.req.info.FilterSetupRequest;
import com.glxp.udi.admin.service.info.SetupService;
import com.glxp.udi.common.res.BaseResponse;
import com.glxp.udi.common.util.ResultVOUtils;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;

@RestController
public class SetupController {

    @Resource
    private SetupService setupService;

    @GetMapping("/udi/info/setup")
    public BaseResponse getCompanyInfo(FilterSetupRequest filterSetupRequest) {
        filterSetupRequest.setId(1);
        SetupEntity setupEntity = setupService.findSetup(filterSetupRequest);
        if (setupEntity != null) {
            return ResultVOUtils.success(setupEntity);
        }
        return ResultVOUtils.error(500, "设置信息为空");
    }

    @PostMapping("/udi/info/setup/modify")
    public BaseResponse modifyCompany(@RequestBody SetupEntity setupEntity) {
        setupEntity.setId(1);
        setupService.modifySetup(setupEntity);
        return ResultVOUtils.success("修改成功");
    }

}
