package com.glxp.udi.admin.controller.publish;

import com.glxp.udi.admin.dao.publish.ProductClassifyDao;
import com.glxp.udi.admin.entity.publish.ProductClassifyEntity;
import com.glxp.udi.admin.req.publish.ProductclassifyRequest;
import com.glxp.udi.admin.res.publish.ProductClassifyResponse;
import com.glxp.udi.common.enums.ResultEnum;
import com.glxp.udi.common.res.BaseResponse;
import com.glxp.udi.common.util.ResultVOUtils;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import javax.validation.Valid;
import java.util.ArrayList;
import java.util.List;


@RestController
public class ProductClassifyController {

    @Resource
    ProductClassifyDao productClassifyDao;

    //    @AuthRuleAnnotation("")
    @GetMapping("/udims/subProduct/productclassify")
    public BaseResponse listClassify( @Valid ProductclassifyRequest productclassifyRequest, BindingResult bindingResult) {
        if (bindingResult.hasErrors()) {
            return ResultVOUtils.error(ResultEnum.PARAM_VERIFY_FALL, bindingResult.getFieldError().getDefaultMessage());
        }
        List<ProductClassifyResponse> options = new ArrayList<>();
        if (productclassifyRequest.getQXLB().equals("器械")) {
            List<ProductClassifyEntity> levelList1 = productClassifyDao.selectAll(new ProductclassifyRequest("1", "器械"));
            List<ProductClassifyEntity> levelList2 = productClassifyDao.selectAll(new ProductclassifyRequest("2", "器械"));
            List<ProductClassifyEntity> levelList3 = productClassifyDao.selectAll(new ProductclassifyRequest("3", "器械"));
            for (int i = 0; i < levelList1.size(); i++) {
                ProductClassifyEntity productClassifyEntity = levelList1.get(i);
                ProductClassifyResponse productClassifyResponse = new ProductClassifyResponse();
                productClassifyResponse.setLabel("("+productClassifyEntity.getId()+")"+productClassifyEntity.getName());
                productClassifyResponse.setValue(productClassifyEntity.getId());
                List<ProductClassifyResponse> l2productClassifyResponses = new ArrayList<>();
                for (int j = 0; j < levelList2.size(); j++) {
                    ProductClassifyEntity leve2Pce = levelList2.get(j);
                    if (leve2Pce.getProductClassify_FK().equals(productClassifyEntity.getProductClassifyOID())) {
                        ProductClassifyResponse lv2Res = new ProductClassifyResponse();
                        lv2Res.setLabel("("+leve2Pce.getId()+")"+leve2Pce.getName());
                        lv2Res.setValue(leve2Pce.getId());
                        List<ProductClassifyResponse> l3productClassifyResponses = new ArrayList<>();
                        for (int k = 0; k < levelList3.size(); k++) {
                            ProductClassifyEntity leve3Pce = levelList3.get(k);
                            if (leve3Pce.getProductClassify_FK().equals(leve2Pce.getProductClassifyOID())) {
                                ProductClassifyResponse lv3Res = new ProductClassifyResponse();
                                lv3Res.setLabel("("+leve3Pce.getId()+")"+leve3Pce.getName());
                                lv3Res.setValue(leve3Pce.getId());
                                l3productClassifyResponses.add(lv3Res);
                            }
                        }
                        lv2Res.setChildren(l3productClassifyResponses);
                        l2productClassifyResponses.add(lv2Res);
                    }
                }
                productClassifyResponse.setChildren(l2productClassifyResponses);
                options.add(productClassifyResponse);
            }
        } else if (productclassifyRequest.getQXLB().equals("体外诊断试剂")) {
            List<ProductClassifyEntity> levelList1 = productClassifyDao.selectAll(new ProductclassifyRequest("1", "体外诊断试剂"));
            List<ProductClassifyEntity> levelList2 = productClassifyDao.selectAll(new ProductclassifyRequest("2", "体外诊断试剂"));
            for (int i = 0; i < levelList1.size(); i++) {
                ProductClassifyEntity productClassifyEntity = levelList1.get(i);
                ProductClassifyResponse productClassifyResponse = new ProductClassifyResponse();
                productClassifyResponse.setLabel("("+productClassifyEntity.getId()+")"+productClassifyEntity.getName());
                productClassifyResponse.setValue(productClassifyEntity.getId());
                List<ProductClassifyResponse> l2productClassifyResponses = new ArrayList<>();
                for (int j = 0; j < levelList2.size(); j++) {
                    ProductClassifyEntity leve2Pce = levelList2.get(j);
                    if (leve2Pce.getProductClassify_FK().equals(productClassifyEntity.getProductClassifyOID())) {
                        ProductClassifyResponse lv2Res = new ProductClassifyResponse();
                        lv2Res.setLabel("("+leve2Pce.getId()+")"+leve2Pce.getName());
                        lv2Res.setValue(leve2Pce.getId());
                        l2productClassifyResponses.add(lv2Res);
                    }
                }
                productClassifyResponse.setChildren(l2productClassifyResponses);
                options.add(productClassifyResponse);
            }
        }
        return ResultVOUtils.success(options);

    }
}
