package com.glxp.udi.admin.dao.inout;

import com.glxp.udi.admin.entity.inout.OrderEntity;
import com.glxp.udi.admin.entity.inout.WarehouseEntity;
import com.glxp.udi.admin.req.inout.OrderFilterRequest;
import com.glxp.udi.admin.req.inout.OrderQueryRequest;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

@Mapper
public interface OrderDao {

    List<OrderEntity> listOrder(OrderQueryRequest orderQueryRequest);

    boolean insertOrder(OrderEntity orderEntity);

    boolean updateOrder(OrderEntity orderEntity);

    List<OrderEntity> listOrderError(OrderQueryRequest orderQueryRequest);

    List<OrderEntity> listOrderRepeat(OrderQueryRequest orderQueryRequest);

    boolean deleteByOrderId(@Param("orderId") String orderId);

    boolean deleteById(@Param("id") String id);

    boolean updateUnit(OrderEntity orderEntity);

    boolean updateOrderStatus(@Param("orderId") String orderId, @Param("status") String status);

    boolean updateExportStatus(@Param("orderId") String orderId, @Param("exportStatus") String exportStatus);

    boolean updateContrastStatus(@Param("orderId") String orderId, @Param("contrastStatus") String contrastStatus);

    boolean updateSignStatus(@Param("orderId") String orderId, @Param("signStatus") String signStatus);

    boolean updateRemark(@Param("orderId") String orderId, @Param("remark") String remark);

    List<OrderEntity> filterList(OrderFilterRequest orderFilterRequest);

    List<OrderEntity> filterListByCode(@Param("warehouseEntityList") List<WarehouseEntity> warehouseEntityList);

    OrderEntity findOne(OrderFilterRequest orderFilterRequest);


}
