package com.glxp.udi.admin.dao.inout;

import com.glxp.udi.admin.entity.inout.WarehouseEntity;
import com.glxp.udi.admin.req.inout.FilterWarehouseRequest;
import com.glxp.udi.admin.req.inout.WarehouseQueryRequest;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

@Mapper
public interface WarehouseDao {

    List<WarehouseEntity> listWarehouse(WarehouseQueryRequest warehouseQueryRequest);

    boolean insertWarehouse(WarehouseEntity warehouseEntity);

    boolean insertWarehouses(@Param("warehouseEntities") List<WarehouseEntity> warehouseEntities);

    List<WarehouseEntity> findByNo(WarehouseQueryRequest warehouseQueryRequest);

    Integer isExit(WarehouseEntity warehouseEntity);

    List<WarehouseEntity> findByOrderId(WarehouseQueryRequest warehouseQueryRequest);

    List<WarehouseEntity> findByReceiptId(@Param("orderId") String orderId);

    List<WarehouseEntity> findByCode(FilterWarehouseRequest filterWarehouseRequest);

    List<WarehouseEntity> searchCode(@Param("code") String code, @Param("customerId")Long customerId);

    boolean updateOrderId(@Param("oldOrderId") String oldOrderId, @Param("newOrderId") String newOrderId);

    boolean updateUnit(@Param("orderId") String orderId, @Param("fromCorpID") String fromCorpID, @Param("fromCorp") String fromCorp);

    List<String> findCodesById(@Param("orderId") String orderId);

}
