package com.glxp.udi.admin.dao.publish;

import com.glxp.udi.admin.entity.publish.PostSuccessBean;
import com.glxp.udi.admin.entity.publish.UdiDeviceIdEntity;
import com.glxp.udi.admin.req.publish.DeleteUdiDeviceIdRequest;
import com.glxp.udi.admin.req.publish.FilterDeviceIdRequest;
import com.glxp.udi.admin.res.publish.UdiDeviceIdResponse;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

@Mapper
public interface UdiDeviceIdDao {

    boolean insertUdiDeviceId(UdiDeviceIdEntity UdiDeviceIdEntity);

    boolean insertUdiDeviceIdList(@Param("UdiDeviceIdEntities") List<UdiDeviceIdEntity> UdiDeviceIdEntities);

    boolean deleteUdiDeviceId(DeleteUdiDeviceIdRequest deleteUdiDeviceIdRequest);

    boolean modifyUdiDeviceId(UdiDeviceIdEntity UdiDeviceIdEntity);

    boolean postUpdate(PostSuccessBean successListBean);

    List<UdiDeviceIdEntity> selectBySubProductId(String SubProductId);

    List<UdiDeviceIdResponse> selectByProductId(FilterDeviceIdRequest filterDeviceIdRequest);

    List<UdiDeviceIdResponse> selectByByIds(List<String> ids);

    List<UdiDeviceIdResponse> selectKeysByIds(List<String> ids);

    UdiDeviceIdEntity selectByPriId(String primaryDeviceId);

    UdiDeviceIdEntity selectById(String UDI_DeviceIdOID);

}
