package com.glxp.udi.admin.dao.receipt;

import com.glxp.udi.admin.entity.inout.ErpDetailCodeEntity;
import com.glxp.udi.admin.entity.inout.OrderDetailEntity;
import com.glxp.udi.admin.entity.receipt.ProductInfoEntity;
import com.glxp.udi.admin.req.receipt.ProductInfoFilterRequest;
import com.glxp.udi.admin.res.inout.ProductInfoResponse;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

@Mapper
public interface ProductInfoDao {

    List<ProductInfoEntity> filterList(ProductInfoFilterRequest productInfoFilterRequest);

    List<ProductInfoResponse> filterDrugList(ProductInfoFilterRequest productInfoFilterRequest);

    List<ProductInfoResponse> filterDrugListByUuid(ProductInfoFilterRequest productInfoFilterRequest);

    List<ProductInfoResponse> filterUdiList(ProductInfoFilterRequest productInfoFilterRequest);

    boolean insertProductInfo(ProductInfoEntity productInfoEntity);

    boolean deleteById(@Param("id") String id);

    boolean deleteAll(@Param("ids") List<String> ids);

    ProductInfoEntity selectById(@Param("id") String id);

    boolean updateProductInfo(ProductInfoEntity productInfoEntity);

    boolean updateUseDy(ProductInfoEntity productInfoEntity);


    List<OrderDetailEntity> findByCodes(@Param("coedes") List<String> codes);

    String isExit(@Param("nameCode") String nameCode);

    ErpDetailCodeEntity getDetailCode(@Param("code") String code);

    ErpDetailCodeEntity getDetailCodeNoBh(@Param("code") String code);

    List<String> findNameCodeByGid(@Param("goodsId") String goodsId);
}
