package com.glxp.udi.admin.entity.publish;

import com.fasterxml.jackson.annotation.JsonAutoDetect;
import lombok.Data;

import java.util.List;
@Data
@JsonAutoDetect(fieldVisibility = JsonAutoDetect.Visibility.ANY,getterVisibility = JsonAutoDetect.Visibility.NONE)
public class PostDataBean {

        /**
         * uploadType : 数据申报类型： add:新增,modify：修改编辑,change：公示数据变更
         * deviceRecordKey : 当数据申报类型为 modify 或 change时，数据库记录 key 必填
         * ZXXSDYCPBS : 最小销售单元产品标识
         * ZXXSDYZSYDYDSL : 最小销售单元中使用单元的数量
         * SYDYCPBS : 使用单元产品标识
         * CPBSBMTXMC : 产品标识编码体系名称，如 GS1， MA 码 （IDcode）
         * SFYBTZJBS : 是否包含本体标识； 1 是 0 否
         * BTCPBSYZXXSDYCPBSSFYZ : 是否与最小销售单元产品标识是否一致； 1 是 0 否
         * BTCPBS : 医疗器械本体标识中的产品标识
         * BSZT :
         * SFYZCBAYZ : 是否与注册/备案标识一致； 1 是 0 否
         * ZCBACPBS : 注册/备案产品标识
         * CPBSFBRQ : 产品标识发布时间； 格式:2019-09-12
         * CPMCTYMC : 产品名称/通用名称
         * SPMC : 商品名称
         * GGXH : 规格型号
         * SFWBLZTLCP : 医疗器械是否为包类/组套类产品： 1 是 0 否
         * CPMS : 产品描述信息
         * CPHHHBH : 产品货号或编号
         * CPLX : 产品类型： 1 器械 ； 2 体外诊断试剂
         * FLBM : 器械目录分类代码， 数据格式按照： 器械分类编码-一级分类编码-二级分类编码（01-01-01） ， 一级、 二级分类不明确的情况下用 00代替； 产品类型为体外试剂时： 数据格式为： 6840-001
         * YFLBM : 原器械目录分类代码
         * YLQXZCRBARMC : 注册/备案人名称
         * YLQXZCRBARYWMC : 注册/备案证对应的注册人/备案人的英文名称
         * TYSHXYDM : 统一社会信用代码， 境外企业填写境内代理人的统一社会信用代码
         * ZCZBHHZBAPZBH : 注册/备案证号， 多个之间用英文状态‘,’分隔
         * HCHZSB : 耗材或者设备： 0 耗材， 1 设备
         * SFBJWYCXSY : 标记为一次性使用： 0 否， 1 是
         * ZDCFSYCS : 医疗器械的最大重复使用次数
         * SFWWJBZ : 医疗器械是否为已灭菌产品： 1 是 0 否
         * SYQSFXYJXMJ : 医疗器械使用前是否需要进行灭菌； 1 是 0否
         * MJFS : 医疗器械的灭菌方式
         * YBBM : 医保编码
         * CGZMRAQXGXX : 磁共振（MR） 安全相关信息； 0 安全 ， 1 条件安全， 2 不安全 ， 3 说明书或标签上面不包括 MR 安全信息
         * devicePackage : [{"BZCPBS":"包装产品标识","BZNHXYJBZCPBS":"包装内含下一级包装产品标识 ","BZNHXYJCPBSSL":"包装内含下一级产品标识数量 ","CPBZJB":"包装级别"}]
         * deviceStorage : [{"CCHCZTJ":"储存或操作条件","ZDZ":"最低值","ZGZ":"最高值","JLDW":"计量单位"}]
         * TSCCHCZTJ : 特殊存储或操作条件
         * deviceClinical : [{"LCSYCCLX":"尺寸类型","CCZ":"尺寸值","CCDW":"计量单位"}]
         * TSCCSM : 特殊使用尺寸说明
         * SCBSSFBHPH :
         * SCBSSFBHXLH : 医疗器械生产标识是否包含序列号： 1 是 0否
         * SCBSSFBHSCRQ : 医疗器械生产标识是否包含生产日期： 1 是0 否
         * SCBSSFBHSXRQ : 医疗器械生产标识是否包含失效日期： 1 是0 否
         * QTXXDWZLJ : 其他信息的网址链接
         * TSRQ : 医疗器械在流通领域停止销售的时间
         * BGSM : 变更说明
         */

        private String uploadType;
        private String deviceRecordKey;
        private String ZXXSDYCPBS;
        private String ZXXSDYZSYDYDSL;
        private String SYDYCPBS;
        private String CPBSBMTXMC;
        private String SFYBTZJBS;
        private String BTCPBSYZXXSDYCPBSSFYZ;
        private String BTCPBS;
        private String BSZT;
        private String SFYZCBAYZ;
        private String ZCBACPBS;
        private String CPBSFBRQ;
        private String CPMCTYMC;
        private String SPMC;
        private String GGXH;
        private String SFWBLZTLCP;
        private String CPMS;
        private String CPHHHBH;
        private String CPLX;
        private String FLBM;
        private String YFLBM;
        private String YLQXZCRBARMC;
        private String YLQXZCRBARYWMC;
        private String TYSHXYDM;
        private String ZCZBHHZBAPZBH;
        private String HCHZSB;
        private String SFBJWYCXSY;
        private String ZDCFSYCS;
        private String SFWWJBZ;
        private String SYQSFXYJXMJ;
        private String MJFS;
        private String YBBM;
        private String CGZMRAQXGXX;
        private String TSCCHCZTJ;
        private String TSCCSM;
        private String SCBSSFBHPH;
        private String SCBSSFBHXLH;
        private String SCBSSFBHSCRQ;
        private String SCBSSFBHSXRQ;
        private String QTXXDWZLJ;
        private String TSRQ;
        private String BGSM;
        private List<PostDevicePackageBean> devicePackage;
        private List<PostDeviceStorageBean> deviceStorage;
        private List<PostDeviceClinicalBean> deviceClinical;


}
