package com.glxp.udi.admin.service.auth.impl;

import com.github.pagehelper.PageHelper;
import com.glxp.udi.admin.dao.auth.CustomerContacDao;
import com.glxp.udi.admin.entity.auth.CustomerContactEntity;
import com.glxp.udi.admin.req.auth.CustomerContactFilterRequest;
import com.glxp.udi.admin.req.inout.DeleteRequest;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;

@Service
public class CustomerContactServiceImpl implements CustomerContactService {


    @Resource
    private CustomerContacDao customerContacDao;

    @Override
    public List<CustomerContactEntity> filterCustomerContact(CustomerContactFilterRequest customerContactFilterRequest) {
        if (customerContactFilterRequest == null) {
            return Collections.emptyList();
        }
        int offset = (customerContactFilterRequest.getPage() - 1) * customerContactFilterRequest.getLimit();
        PageHelper.offsetPage(offset, customerContactFilterRequest.getLimit());
        return customerContacDao.filterCustomerContact(customerContactFilterRequest);
    }

    @Override
    public boolean insertCustomerContact(CustomerContactEntity customerContactEntity) {
        return customerContacDao.insertCustomerContact(customerContactEntity);
    }

    @Override
    public boolean updateCustomerContact(CustomerContactEntity customerContactEntity) {
        return customerContacDao.updateCustomerContact(customerContactEntity);
    }

    @Override
    public boolean deleteById(Long id) {
        return customerContacDao.deleteById(id);
    }

    @Override
    public boolean deleteContact(DeleteRequest deleteRequest) {
        return customerContacDao.deleteContact(deleteRequest);
    }


    @Override
    public CustomerContactEntity selectById(Long emailId) {
        return customerContacDao.selectById(emailId);
    }
}
