package com.glxp.udi.admin.service.auth.impl;

import com.github.pagehelper.PageHelper;
import com.glxp.udi.admin.dao.auth.UserRegisterDao;
import com.glxp.udi.admin.entity.auth.UserRegisterEntity;
import com.glxp.udi.admin.req.auth.UserResisterFilterRequest;
import com.glxp.udi.admin.service.auth.UserRegisterService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;

@Service
public class UserRegisterServiceImpl implements UserRegisterService {

    @Resource
    private UserRegisterDao userRegisterDao;


    @Override
    public List<UserRegisterEntity> filterUserRegisters(UserResisterFilterRequest userResisterFilterRequest) {
        if (userResisterFilterRequest == null) {
            return Collections.emptyList();
        }
        int offset = (userResisterFilterRequest.getPage() - 1) * userResisterFilterRequest.getLimit();
        PageHelper.offsetPage(offset, userResisterFilterRequest.getLimit());
        return userRegisterDao.filterUserRegisters(userResisterFilterRequest);
    }

    @Override
    public boolean insertUserRegister(UserRegisterEntity userRegisterEntity) {
        return userRegisterDao.insertUserRegister(userRegisterEntity);
    }

    @Override
    public boolean updateUserRegister(UserRegisterEntity userRegisterEntity) {
        return userRegisterDao.updateUserRegister(userRegisterEntity);
    }

    @Override
    public boolean deleteById(Long id) {
        return userRegisterDao.deleteById(id);
    }



    @Override
    public UserRegisterEntity selectById(Integer id) {
        return userRegisterDao.selectById(id);
    }

    @Override
    public boolean isExit(String phoneNum) {
        String data = userRegisterDao.isExit(phoneNum);
        if (data != null)
            return true;
        else
            return false;
    }

    @Override
    public boolean deleteByCustomerId(Long id) {
        return userRegisterDao.deleteByCustomerId(id);
    }

    @Override
    public UserRegisterEntity selectByCustomerId(Long id) {
        return userRegisterDao.selectByCustomerId(id);
    }
}
