package com.glxp.udi.admin.service.info.impl;

import com.github.pagehelper.PageHelper;
import com.glxp.udi.admin.dao.info.EnterpriseCertDao;
import com.glxp.udi.admin.entity.info.EnterpriseCertEntity;
import com.glxp.udi.admin.req.info.DeleteEnterpriseCertRequest;
import com.glxp.udi.admin.req.info.FilterEnterpriseCertRequest;
import com.glxp.udi.admin.service.info.EnterpriseCertService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;

@Service
public class EnterpriseCertServiceImpl implements EnterpriseCertService {

    @Resource
    EnterpriseCertDao enterpriseCertDao;
    @Override
    public boolean insertEnterpriseCert(EnterpriseCertEntity enterpriseCertEntity) {
        return enterpriseCertDao.insertEnterpriseCert(enterpriseCertEntity);
    }

    @Override
    public boolean insertEnterpriseCertList(List<EnterpriseCertEntity> enterpriseCertEntities) {
        return enterpriseCertDao.insertEnterpriseCertList(enterpriseCertEntities);
    }

    @Override
    public boolean deleteEnterpriseCert(DeleteEnterpriseCertRequest deleteEnterpriseCertRequest) {
        return enterpriseCertDao.deleteEnterpriseCert(deleteEnterpriseCertRequest);
    }

    @Override
    public boolean modifyEnterpriseCert(EnterpriseCertEntity enterpriseCertEntity) {
        return enterpriseCertDao.modifyEnterpriseCert(enterpriseCertEntity);
    }

    @Override
    public List<EnterpriseCertEntity> filterEnterpriseCerts(FilterEnterpriseCertRequest filterEnterpriseCertRequest) {
        if (filterEnterpriseCertRequest == null) {
            return Collections.emptyList();
        }
        int offset = (filterEnterpriseCertRequest.getPage() - 1) * filterEnterpriseCertRequest.getLimit();
        PageHelper.offsetPage(offset, filterEnterpriseCertRequest.getLimit());
        List<EnterpriseCertEntity> enterpriseCertEntities = enterpriseCertDao.filterEnterpriseCerts(filterEnterpriseCertRequest);
        return enterpriseCertEntities;
    }
}
