package com.glxp.udi.admin.service.inout;

import com.glxp.udi.admin.entity.inout.WarehouseEntity;
import com.glxp.udi.admin.entity.inout.Warehousetemp;
import com.glxp.udi.admin.req.inout.CommitRequest;
import com.glxp.udi.admin.req.inout.FilterWarehouseRequest;
import com.glxp.udi.admin.req.inout.WarehouseQueryRequest;

import java.util.List;

public interface WarehouseService {
    List<WarehouseEntity> listWarehouse(WarehouseQueryRequest warehouseQueryRequest);

    boolean insertWarehouse(WarehouseEntity warehouseEntity);

    boolean insertWarehouses(List<WarehouseEntity> warehouseEntities);

    boolean insertTempWarehouses(List<Warehousetemp> warehouseEntities);

    boolean deleteTempWarehouses(List<Long> warehouseEntities);

    List<WarehouseEntity> findByNo(WarehouseQueryRequest warehouseQueryRequest);

    boolean isExits(WarehouseEntity warehouseEntity);

    List<WarehouseEntity> findByOrderId(WarehouseQueryRequest warehouseQueryRequest);


    List<WarehouseEntity> findAllByOrderId(WarehouseQueryRequest warehouseQueryRequest);

    List<WarehouseEntity> findByReceiptId(String orderId);

    List<Warehousetemp> findTempByOrderId(CommitRequest commitRequest);

    List<Warehousetemp> findErrorByOrderId(WarehouseQueryRequest warehouseQueryRequest);

    List<WarehouseEntity> findByCode(FilterWarehouseRequest filterWarehouseRequest);

    boolean updateOrderId(String oldOrderId, String newOrderId);

    List<WarehouseEntity> searchCode(String code,Long customerId);

    boolean updateUnit(String orderId, String fromCorpID, String fromCorp);
}
