package com.glxp.udi.admin.service.inout.impl;

import com.github.pagehelper.PageHelper;
import com.glxp.udi.admin.dao.inout.BusRoleRlDao;
import com.glxp.udi.admin.entity.inout.BusRoleRlEntity;
import com.glxp.udi.admin.req.inout.BusRoleRlFilterRequest;
import com.glxp.udi.admin.res.inout.BusRoleRlResponse;
import com.glxp.udi.admin.service.inout.BusRoleRlService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;

@Service
public class BusRoleRlServiceImpl implements BusRoleRlService {


    @Resource
    BusRoleRlDao busRoleRlDao;

    @Override

    public List<BusRoleRlEntity> filterList(BusRoleRlFilterRequest bussinessTypeFilterRequest) {
        if (bussinessTypeFilterRequest == null) {
            return Collections.emptyList();
        }
        if (bussinessTypeFilterRequest.getPage() != null) {
            int offset = (bussinessTypeFilterRequest.getPage() - 1) * bussinessTypeFilterRequest.getLimit();
            PageHelper.offsetPage(offset, bussinessTypeFilterRequest.getLimit());
        }
        List<BusRoleRlEntity> data = busRoleRlDao.filterList(bussinessTypeFilterRequest);
        return data;
    }

    @Override
    public List<BusRoleRlResponse> filterJoinList(BusRoleRlFilterRequest bussinessTypeFilterRequest) {
        if (bussinessTypeFilterRequest == null) {
            return Collections.emptyList();
        }
        if (bussinessTypeFilterRequest.getPage() != null) {
            int offset = (bussinessTypeFilterRequest.getPage() - 1) * bussinessTypeFilterRequest.getLimit();
            PageHelper.offsetPage(offset, bussinessTypeFilterRequest.getLimit());
        }
        List<BusRoleRlResponse> data = busRoleRlDao.filterJoinList(bussinessTypeFilterRequest);
        return data;
    }

    @Override
    public boolean insertBusRoleRl(BusRoleRlEntity bussinessTypeEntity) {
        return busRoleRlDao.insertBusRoleRl(bussinessTypeEntity);
    }

    @Override
    public boolean updateBusRoleRl(BusRoleRlEntity bussinessTypeEntity) {
        return busRoleRlDao.updateBusRoleRl(bussinessTypeEntity);
    }

    @Override
    public boolean deleteById(String id) {
        return busRoleRlDao.deleteById(id);
    }
}
