package com.glxp.udi.admin.service.inout.impl;

import com.github.pagehelper.PageHelper;
import com.glxp.udi.admin.dao.inout.CodeNeedRlDao;
import com.glxp.udi.admin.entity.inout.CodeNeedRlEntity;
import com.glxp.udi.admin.req.inout.CodeNeedRlFilterRequest;
import com.glxp.udi.admin.service.inout.CodeNeedRlService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;

@Service
public class CodeNeedRlServiceImpl implements CodeNeedRlService {

    @Resource
    CodeNeedRlDao codeNeedRlDao;

    @Override
    public List<CodeNeedRlEntity> filterList(CodeNeedRlFilterRequest codeNeedRlFilterRequest) {
        if (codeNeedRlFilterRequest == null) {
            return Collections.emptyList();
        }
        int offset = (codeNeedRlFilterRequest.getPage() - 1) * codeNeedRlFilterRequest.getLimit();
        PageHelper.offsetPage(offset, codeNeedRlFilterRequest.getLimit());
        List<CodeNeedRlEntity> data = codeNeedRlDao.filterList(codeNeedRlFilterRequest);
        return data;
    }

    @Override
    public boolean insertCodeNeedRl(CodeNeedRlEntity codeNeedRlEntity) {
        return codeNeedRlDao.insertCodeNeedRl(codeNeedRlEntity);
    }

    @Override
    public boolean updateCodeNeedRl(CodeNeedRlEntity codeNeedRlEntity) {
        return codeNeedRlDao.updateCodeNeedRl(codeNeedRlEntity);
    }

    @Override
    public boolean deleteById(String id) {
        return codeNeedRlDao.deleteById(id);
    }
}
