package com.glxp.udi.admin.service.inout.impl;

import com.github.pagehelper.PageHelper;
import com.glxp.udi.admin.dao.inout.MyErpOrderDao;
import com.glxp.udi.admin.entity.inout.ErpOrderEntity;
import com.glxp.udi.admin.req.inout.FilterErpOrderRequest;
import com.glxp.udi.admin.service.inout.MyErpOrderService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;

@Service
public class MyErpOrderServiceImpl implements MyErpOrderService {

    @Resource
    MyErpOrderDao myErpOrderDao;

    @Override
    public List<ErpOrderEntity> filterAllMyErpOrder(FilterErpOrderRequest filterErpOrderRequest) {
        if (filterErpOrderRequest == null) {
            return Collections.emptyList();
        }

        return myErpOrderDao.filterMyErpOrder(filterErpOrderRequest);
    }

    @Override
    public List<ErpOrderEntity> findByStockCheck(FilterErpOrderRequest filterErpOrderRequest) {

        if (filterErpOrderRequest == null) {
            return Collections.emptyList();
        }
        int offset = (filterErpOrderRequest.getPage() - 1) * filterErpOrderRequest.getLimit();
        PageHelper.offsetPage(offset, filterErpOrderRequest.getLimit());
        return myErpOrderDao.findByStockCheck(filterErpOrderRequest.getOrderIds());
    }

    @Override
    public List<ErpOrderEntity> filterMyErpOrder(FilterErpOrderRequest filterErpOrderRequest) {
        if (filterErpOrderRequest == null) {
            return Collections.emptyList();
        }
        int offset = (filterErpOrderRequest.getPage() - 1) * filterErpOrderRequest.getLimit();
        PageHelper.offsetPage(offset, filterErpOrderRequest.getLimit());
        return myErpOrderDao.filterMyErpOrder(filterErpOrderRequest);
    }

    @Override
    public List<ErpOrderEntity> filterMyErpMainOrder(FilterErpOrderRequest filterErpOrderRequest) {
        if (filterErpOrderRequest == null) {
            return Collections.emptyList();
        }
        int offset = (filterErpOrderRequest.getPage() - 1) * filterErpOrderRequest.getLimit();
        PageHelper.offsetPage(offset, filterErpOrderRequest.getLimit());
        return myErpOrderDao.filterMyErpMainOrder(filterErpOrderRequest);
    }

    @Override
    public List<ErpOrderEntity> filterMyErpDetailOrder(FilterErpOrderRequest filterErpOrderRequest) {
        if (filterErpOrderRequest == null) {
            return Collections.emptyList();
        }
        if (filterErpOrderRequest.getPage() != null && filterErpOrderRequest.getLimit() != null) {
            int offset = (filterErpOrderRequest.getPage() - 1) * filterErpOrderRequest.getLimit();
            PageHelper.offsetPage(offset, filterErpOrderRequest.getLimit());
        }

        return myErpOrderDao.filterMyErpDetailOrder(filterErpOrderRequest);
    }

    @Override
    public List<ErpOrderEntity> findAllByDocids(List<String> docids) {
        return myErpOrderDao.findAllByDocids(docids);
    }

    @Override
    public List<String> filterAllDocid(FilterErpOrderRequest filterErpOrderRequest) {
        return myErpOrderDao.filterAllDocid(filterErpOrderRequest);
    }

    @Override
    public List<ErpOrderEntity> filterAllDocidE(FilterErpOrderRequest filterErpOrderRequest) {
        return myErpOrderDao.filterAllDocidE(filterErpOrderRequest);
    }

    @Override
    public boolean insertErpOrders(List<ErpOrderEntity> erpOrderEntities) {
        return myErpOrderDao.insertErpOrders(erpOrderEntities);
    }

    @Override
    public boolean insertErpOrder(ErpOrderEntity erpOrderEntity) {
        return myErpOrderDao.insertErpOrder(erpOrderEntity);
    }

    @Override
    public boolean updateErpOrder(ErpOrderEntity erpOrderEntity) {
        return myErpOrderDao.updateErpOrder(erpOrderEntity);
    }

    @Override
    public List<String> selectAllIds(List<String> docids) {
        return myErpOrderDao.selectAllIds(docids);
    }

    @Override
    public boolean deleteById(String id) {
        return myErpOrderDao.deleteById(id);
    }

    @Override
    public boolean deleteByPrimiyId(String id) {
        return myErpOrderDao.deleteByPrimiyId(id);
    }

    @Override
    public boolean deleteByOrderId(String id) {
        return myErpOrderDao.deleteByOrderId(id);
    }

}
