package com.glxp.udi.admin.service.inout.impl;

import com.github.pagehelper.PageHelper;
import com.glxp.udi.admin.dao.inout.UnitMaintainDao;
import com.glxp.udi.admin.entity.inout.UnitMaintainEntity;
import com.glxp.udi.admin.req.inout.UnitMaintainFilterRequest;
import com.glxp.udi.admin.service.inout.UnitMaintainService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;

@Service
public class UnitMaintainServiceImpl implements UnitMaintainService {

    @Resource
    UnitMaintainDao unitMaintainDao;

    @Override
    public List<UnitMaintainEntity> filterList(UnitMaintainFilterRequest unitMaintainFilterRequest) {
        if (unitMaintainFilterRequest == null) {
            return Collections.emptyList();
        }
        int offset = (unitMaintainFilterRequest.getPage() - 1) * unitMaintainFilterRequest.getLimit();
        PageHelper.offsetPage(offset, unitMaintainFilterRequest.getLimit());
        List<UnitMaintainEntity> data = unitMaintainDao.filterList(unitMaintainFilterRequest);
        return data;
    }

    @Override
    public boolean insertUnitMaintain(UnitMaintainEntity unitMaintainEntity) {
        return unitMaintainDao.insertUnitMaintain(unitMaintainEntity);
    }

    @Override
    public boolean deleteById(String id) {
        return unitMaintainDao.deleteById(id);
    }

    @Override
    public UnitMaintainEntity selectById(String id) {
        return unitMaintainDao.selectById(id);
    }

    @Override
    public boolean updateUnit(UnitMaintainEntity unitMaintainEntity) {
        return unitMaintainDao.updateUnit(unitMaintainEntity);
    }
}
