package com.glxp.udi.admin.service.inout.impl;

import com.github.pagehelper.PageHelper;
import com.glxp.udi.admin.dao.inout.UnitDao;
import com.glxp.udi.admin.entity.inout.Unit;
import com.glxp.udi.admin.req.ListPageRequest;
import com.glxp.udi.admin.req.inout.UnitKeyRequest;
import com.glxp.udi.admin.req.inout.UnitSaveRequest;
import com.glxp.udi.admin.service.inout.UnitService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;

@Service
public class UnitServiceImpl implements UnitService {

    @Resource
    private UnitDao unitDao;


    @Override
    public List<Unit> listUnit(ListPageRequest listPageRequest) {
        if (listPageRequest == null) {
            return Collections.emptyList();
        }
        int offset = (listPageRequest.getPage() - 1) * listPageRequest.getLimit();
        PageHelper.offsetPage(offset, listPageRequest.getLimit());
        List<Unit> units = unitDao.listUnitKey("");
        return units;
    }

    @Override
    public List<Unit> listUnitKey(UnitKeyRequest unitKeyRequest) {
        if (unitKeyRequest == null) {
            return Collections.emptyList();
        }
        int offset = (unitKeyRequest.getPage() - 1) * unitKeyRequest.getLimit();

        PageHelper.offsetPage(offset, unitKeyRequest.getLimit());
        return unitDao.listUnitKey(unitKeyRequest.getKey());
    }

    @Override
    public boolean deletAll() {
        return unitDao.deleteAll();
    }

    @Override
    public Unit selectById(String id) {
        return unitDao.selectById(id);
    }

    @Override
    public int saveUnits(UnitSaveRequest unitSaveRequest) {
        return unitDao.insertUnits(unitSaveRequest.getUnitList());
    }
}
