package com.glxp.udi.admin.service.inout.impl;

import com.github.pagehelper.PageHelper;
import com.glxp.udi.admin.dao.inout.WarehouseDao;
import com.glxp.udi.admin.dao.inout.WarehousetempMapper;
import com.glxp.udi.admin.entity.inout.WarehouseEntity;
import com.glxp.udi.admin.entity.inout.Warehousetemp;
import com.glxp.udi.admin.entity.inout.WarehousetempExample;
import com.glxp.udi.admin.req.inout.CommitRequest;
import com.glxp.udi.admin.req.inout.FilterWarehouseRequest;
import com.glxp.udi.admin.req.inout.WarehouseQueryRequest;
import com.glxp.udi.admin.service.inout.WarehouseService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;

@Service
public class WareHouseServiceImpl implements WarehouseService {

    @Resource
    WarehouseDao warehouseDao;
    @Resource
    WarehousetempMapper warehousetempMapper;

    @Override
    public List<WarehouseEntity> listWarehouse(WarehouseQueryRequest warehouseQueryRequest) {
        if (warehouseQueryRequest == null) {
            return Collections.emptyList();
        }
        int offset = (warehouseQueryRequest.getPage() - 1) * warehouseQueryRequest.getLimit();
        PageHelper.offsetPage(offset, warehouseQueryRequest.getLimit());
        return warehouseDao.listWarehouse(warehouseQueryRequest);
    }


    @Override
    public boolean insertWarehouse(WarehouseEntity warehouseEntity) {
        return warehouseDao.insertWarehouse(warehouseEntity);
    }

    @Override
    public boolean insertWarehouses(List<WarehouseEntity> warehouseEntities) {
        return warehouseDao.insertWarehouses(warehouseEntities);
    }

    @Override
    public boolean insertTempWarehouses(List<Warehousetemp> warehouseEntities) {
        if (warehouseEntities != null) {
            warehousetempMapper.insertTempWarehouses(warehouseEntities);
//            for (int i = 0; i < warehouseEntities.size(); i++) {
//                warehousetempMapper.insert(warehouseEntities.get(i));
//            }
            return true;
        }

        return false;
    }

    @Override
    public boolean deleteTempWarehouses(List<Long> warehouseEntities) {
        if (warehouseEntities != null) {
            warehousetempMapper.deleteTempWarehouses(warehouseEntities);
            return true;
        }

        return false;
    }

    @Override
    public List<WarehouseEntity> findByNo(WarehouseQueryRequest warehouseQueryRequest) {
        if (warehouseQueryRequest == null) {
            return Collections.emptyList();
        }
        int offset = (warehouseQueryRequest.getPage() - 1) * warehouseQueryRequest.getLimit();
        PageHelper.offsetPage(offset, warehouseQueryRequest.getLimit());
        return warehouseDao.findByNo(warehouseQueryRequest);
    }

    @Override
    public boolean isExits(WarehouseEntity warehouseEntity) {

        int result = warehouseDao.isExit(warehouseEntity);
        if (result == 1)
            return true;
        else
            return false;
    }

    @Override
    public List<WarehouseEntity> findByOrderId(WarehouseQueryRequest warehouseQueryRequest) {
        if (warehouseQueryRequest == null) {
            return Collections.emptyList();
        }
        int offset = (warehouseQueryRequest.getPage() - 1) * warehouseQueryRequest.getLimit();
        PageHelper.offsetPage(offset, warehouseQueryRequest.getLimit());
        return warehouseDao.findByOrderId(warehouseQueryRequest);
    }

    @Override
    public List<WarehouseEntity> findAllByOrderId(WarehouseQueryRequest warehouseQueryRequest) {
        if (warehouseQueryRequest == null) {
            return Collections.emptyList();
        }
        return warehouseDao.findByOrderId(warehouseQueryRequest);
    }

    @Override
    public List<WarehouseEntity> findByReceiptId(String orderId) {
        return warehouseDao.findByReceiptId(orderId);
    }

    @Override
    public List<Warehousetemp> findTempByOrderId(CommitRequest commitRequest) {

        if (commitRequest == null) {
            return Collections.emptyList();
        }

        WarehousetempExample warehousetempExample = new WarehousetempExample();
        WarehousetempExample.Criteria criteria = warehousetempExample.createCriteria();
        criteria.andOrderidEqualTo(commitRequest.getOrderId());
        return warehousetempMapper.selectByExample(warehousetempExample);

    }

    @Override
    public List<Warehousetemp> findErrorByOrderId(WarehouseQueryRequest warehouseQueryRequest) {
        if (warehouseQueryRequest == null) {
            return Collections.emptyList();
        }
        int offset = (warehouseQueryRequest.getPage() - 1) * warehouseQueryRequest.getLimit();
        PageHelper.offsetPage(offset, warehouseQueryRequest.getLimit());

        return warehousetempMapper.findErrorByOrderId(warehouseQueryRequest);

    }

    @Override
    public List<WarehouseEntity> findByCode(FilterWarehouseRequest filterWarehouseRequest) {

        return warehouseDao.findByCode(filterWarehouseRequest);
    }

    @Override
    public boolean updateOrderId(String oldOrderId, String newOrderId) {


        return warehouseDao.updateOrderId(oldOrderId, newOrderId);
    }

    @Override
    public List<WarehouseEntity> searchCode(String code,Long customerId) {
        return warehouseDao.searchCode(code,customerId);
    }


    @Override
    public boolean updateUnit(String orderId, String fromCorpID, String fromCorp) {
        return warehouseDao.updateUnit(orderId, fromCorpID, fromCorp);
    }
}
