package com.glxp.udi.admin.service.publish.impl;

import com.github.pagehelper.PageHelper;
import com.glxp.udi.admin.dao.publish.UdiDeviceIdDao;
import com.glxp.udi.admin.entity.publish.PostSuccessBean;
import com.glxp.udi.admin.entity.publish.UdiDeviceIdEntity;
import com.glxp.udi.admin.req.publish.DeleteUdiDeviceIdRequest;
import com.glxp.udi.admin.req.publish.FilterDeviceIdRequest;
import com.glxp.udi.admin.res.publish.UdiDeviceIdResponse;
import com.glxp.udi.admin.service.publish.UdiDeviceIdService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;

@Service
public class UdiDeviceIdServiceImpl implements UdiDeviceIdService {

    @Resource
    UdiDeviceIdDao udiDeviceIdDao;

    @Override
    public boolean insertUdiDeviceId(UdiDeviceIdEntity udiDeviceIdEntity) {
        return udiDeviceIdDao.insertUdiDeviceId(udiDeviceIdEntity);
    }

    @Override
    public boolean insertUdiDeviceIdList(List<UdiDeviceIdEntity> udiDeviceIdEntities) {
        return udiDeviceIdDao.insertUdiDeviceIdList(udiDeviceIdEntities);
    }

    @Override
    public boolean deleteUdiDeviceId(DeleteUdiDeviceIdRequest deleteUdiDeviceIdRequest) {
        return udiDeviceIdDao.deleteUdiDeviceId(deleteUdiDeviceIdRequest);
    }

    @Override
    public boolean modifyUdiDeviceId(UdiDeviceIdEntity udiDeviceIdEntity) {
        return udiDeviceIdDao.modifyUdiDeviceId(udiDeviceIdEntity);
    }

    @Override
    public List<UdiDeviceIdEntity> selectBySubProductId(String subProductId) {
        return udiDeviceIdDao.selectBySubProductId(subProductId);
    }

    @Override
    public List<UdiDeviceIdResponse> selectByProductId(FilterDeviceIdRequest filterDeviceIdRequest) {
        if (filterDeviceIdRequest == null) {
            return Collections.emptyList();
        }
        int offset = (filterDeviceIdRequest.getPage() - 1) * filterDeviceIdRequest.getLimit();
        PageHelper.offsetPage(offset, filterDeviceIdRequest.getLimit());
        List<UdiDeviceIdResponse> udiSubProductEntities = udiDeviceIdDao.selectByProductId(filterDeviceIdRequest);
        return udiSubProductEntities;
    }

    @Override
    public boolean postUpdate(PostSuccessBean successListBean) {
        return udiDeviceIdDao.postUpdate(successListBean);
    }

    @Override
    public UdiDeviceIdEntity selectByPriId(String primaryDeviceId) {
        return udiDeviceIdDao.selectByPriId(primaryDeviceId);
    }

    @Override
    public List<UdiDeviceIdResponse> selectByByIds(List<String> ids) {
        return udiDeviceIdDao.selectByByIds(ids);
    }

    @Override
    public List<UdiDeviceIdResponse> selectKeysByIds(List<String> ids) {
        return udiDeviceIdDao.selectKeysByIds(ids);
    }

    @Override
    public UdiDeviceIdEntity selectById(String UDI_DeviceIdOID) {
        return udiDeviceIdDao.selectById(UDI_DeviceIdOID);
    }
}
