package com.glxp.udi.admin.service.publish.impl;

import com.github.pagehelper.PageHelper;
import com.glxp.udi.admin.dao.publish.UdiProductDao;
import com.glxp.udi.admin.entity.publish.UdiProductEntity;
import com.glxp.udi.admin.req.publish.DeleteUdiProductRequest;
import com.glxp.udi.admin.req.publish.FilterUdiProductRequest;
import com.glxp.udi.admin.service.publish.UdiProductService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;


@Service
public class UdiProductServiceImpl implements UdiProductService {

    @Resource
    UdiProductDao udiProductDao;

    @Override
    public boolean insertUdiProduct(UdiProductEntity UdiProductEntity) {
        return udiProductDao.insertUdiProduct(UdiProductEntity);
    }

    @Override
    public boolean insertUdiProductList(List<UdiProductEntity> udiProductEntities) {
        return udiProductDao.insertUdiProductList(udiProductEntities);
    }

    @Override
    public boolean deleteUdiProduct(DeleteUdiProductRequest deleteUdiProductRequest) {
        return udiProductDao.deleteUdiProduct(deleteUdiProductRequest);
    }

    @Override
    public boolean modifyUdiProduct(UdiProductEntity udiProductEntity) {
        return udiProductDao.modifyUdiProduct(udiProductEntity);
    }

    @Override
    public List<UdiProductEntity> selectByCustomerId(Long customerId) {
        return udiProductDao.selectByCustomerId(customerId);
    }

    @Override
    public UdiProductEntity selectById(String id) {
        return udiProductDao.selectById(id);
    }


    @Override
    public List<UdiProductEntity> filterAll(FilterUdiProductRequest filterCodeContrastRequest) {

        if (filterCodeContrastRequest == null) {
            return Collections.emptyList();
        }
        int offset = (filterCodeContrastRequest.getPage() - 1) * filterCodeContrastRequest.getLimit();
        PageHelper.offsetPage(offset, filterCodeContrastRequest.getLimit());
        List<UdiProductEntity> udiProductEntities= udiProductDao.filterAll(filterCodeContrastRequest);
        return udiProductEntities;
    }


}
