package com.glxp.udi.admin.service.publish.impl;

import com.github.pagehelper.PageHelper;
import com.glxp.udi.admin.dao.publish.UdiSubProductDao;
import com.glxp.udi.admin.entity.publish.UdiSubProductEntity;
import com.glxp.udi.admin.req.publish.DeleteUdiSubProductRequest;
import com.glxp.udi.admin.req.publish.FilterUdiSubProductRequest;
import com.glxp.udi.admin.service.publish.UdiSubProductService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;

@Service
public class UdiSubProductServiceImpl implements UdiSubProductService {

    @Resource
    UdiSubProductDao udiSubProductDao;

    @Override
    public boolean insertUdiSubProduct(UdiSubProductEntity udiSubProductEntity) {
        return udiSubProductDao.insertUdiSubProduct(udiSubProductEntity);
    }

    @Override
    public boolean insertUdiSubProductList(List<UdiSubProductEntity> udiSubProductEntities) {
        return udiSubProductDao.insertUdiSubProductList(udiSubProductEntities);
    }

    @Override
    public boolean deleteUdiSubProduct(DeleteUdiSubProductRequest deleteUdiSubProductRequest) {
        return udiSubProductDao.deleteUdiSubProduct(deleteUdiSubProductRequest);
    }

    @Override
    public boolean modifyUdiSubProduct(UdiSubProductEntity udiSubProductEntity) {
        return udiSubProductDao.modifyUdiSubProduct(udiSubProductEntity);
    }

    @Override
    public List<UdiSubProductEntity> filterAll(FilterUdiSubProductRequest filterCodeContrastRequest) {
        if (filterCodeContrastRequest == null) {
            return Collections.emptyList();
        }
        int offset = (filterCodeContrastRequest.getPage() - 1) * filterCodeContrastRequest.getLimit();
        PageHelper.offsetPage(offset, filterCodeContrastRequest.getLimit());
        List<UdiSubProductEntity> udiSubProductEntities = udiSubProductDao.filterAll(filterCodeContrastRequest);
        return udiSubProductEntities;
    }

    @Override
    public Integer selectCount(String productId) {
        return udiSubProductDao.selectCount(productId);
    }

    @Override
    public UdiSubProductEntity selectById(String UDI_SubProductOID) {
        return udiSubProductDao.selectById(UDI_SubProductOID);
    }
}
