package com.glxp.udi.admin.service.receipts;


import com.glxp.udi.admin.entity.inout.ErpDetailCodeEntity;
import com.glxp.udi.admin.entity.inout.OrderDetailEntity;
import com.glxp.udi.admin.entity.receipt.ProductInfoEntity;
import com.glxp.udi.admin.req.receipt.ProductInfoFilterRequest;
import com.glxp.udi.admin.res.inout.ProductInfoResponse;

import java.util.List;

public interface ProductInfoService {

    List<ProductInfoEntity> filterList(ProductInfoFilterRequest productInfoFilterRequest);

    List<ProductInfoResponse> filterDrugList(ProductInfoFilterRequest productInfoFilterRequest);

    List<ProductInfoResponse> filterDrugListByUuid(ProductInfoFilterRequest productInfoFilterRequest);

    List<ProductInfoResponse> filterUdiList(ProductInfoFilterRequest productInfoFilterRequest);

    boolean insertProductInfo(ProductInfoEntity productInfoEntity);

    boolean updateProductInfo(ProductInfoEntity productInfoEntity);
    boolean updateUseDy(ProductInfoEntity productInfoEntity);
    boolean deleteById(String id);

    boolean deleteAll(List<String> ids);

    ProductInfoEntity selectById(String id);

    List<OrderDetailEntity> findByCodes(List<String> codes);

    List<String> findNameCodeByGid(String goodsId);

    boolean isExit(String nameCode);

    ErpDetailCodeEntity getDetailCode(String code);

    ErpDetailCodeEntity getDetailCodeNoBh(String code);

}
