package com.glxp.udi.admin.service.receipts.impl;


import com.github.pagehelper.PageHelper;
import com.glxp.udi.admin.dao.inout.ManuorderDao;
import com.glxp.udi.admin.entity.receipt.ManuOrderEntity;
import com.glxp.udi.admin.req.receipt.ManuorderFilterRequest;
import com.glxp.udi.admin.service.receipts.ManuorderService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;

@Service
public class ManuorderServiceImpl implements ManuorderService {
    @Resource
    ManuorderDao manuorderDao;

    @Override
    public boolean insertManuorder(List<ManuOrderEntity> manuorders) {
        return manuorderDao.insertManuorder(manuorders);
    }

    @Override
    public List<ManuOrderEntity> filterList(ManuorderFilterRequest manuorderFilterRequest) {
        if (manuorderFilterRequest == null) {
            return Collections.emptyList();
        }
        int offset = (manuorderFilterRequest.getPage() - 1) * manuorderFilterRequest.getLimit();
        PageHelper.offsetPage(offset, manuorderFilterRequest.getLimit());
        List<ManuOrderEntity> data = manuorderDao.filterList(manuorderFilterRequest);
        return data;
    }

    @Override
    public boolean deleteById(String id) {
        return manuorderDao.deleteById(id);
    }

    @Override
    public boolean isExit(String OrderNo) {
        String data = manuorderDao.isExit(OrderNo);
        if (data != null)
            return true;
        else
            return false;
    }
}
