package com.glxp.udi.admin.service.receipts.impl;

import com.github.pagehelper.PageHelper;
import com.glxp.udi.admin.dao.receipt.ProductInfoDao;
import com.glxp.udi.admin.entity.inout.ErpDetailCodeEntity;
import com.glxp.udi.admin.entity.inout.OrderDetailEntity;
import com.glxp.udi.admin.entity.receipt.ProductInfoEntity;
import com.glxp.udi.admin.req.receipt.ProductInfoFilterRequest;
import com.glxp.udi.admin.res.inout.ProductInfoResponse;
import com.glxp.udi.admin.service.receipts.ProductInfoService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;

@Service
public class ProductInfoServiceImpl implements ProductInfoService {

    @Resource
    ProductInfoDao productInfoDao;

    @Override
    public List<ProductInfoEntity> filterList(ProductInfoFilterRequest productInfoFilterRequest) {

        if (productInfoFilterRequest == null) {
            return Collections.emptyList();
        }
        if(productInfoFilterRequest.getPage()!=null){
            int offset = (productInfoFilterRequest.getPage() - 1) * productInfoFilterRequest.getLimit();
            PageHelper.offsetPage(offset, productInfoFilterRequest.getLimit());
        }

        List<ProductInfoEntity> data = productInfoDao.filterList(productInfoFilterRequest);

        return data;
    }

    @Override
    public List<ProductInfoResponse> filterDrugList(ProductInfoFilterRequest productInfoFilterRequest) {
        if (productInfoFilterRequest == null) {
            return Collections.emptyList();
        }
        int offset = (productInfoFilterRequest.getPage() - 1) * productInfoFilterRequest.getLimit();
        PageHelper.offsetPage(offset, productInfoFilterRequest.getLimit());
        List<ProductInfoResponse> data = productInfoDao.filterDrugList(productInfoFilterRequest);
        return data;
    }

    @Override
    public List<ProductInfoResponse> filterDrugListByUuid(ProductInfoFilterRequest productInfoFilterRequest) {
        if (productInfoFilterRequest == null) {
            return Collections.emptyList();
        }
        int offset = (productInfoFilterRequest.getPage() - 1) * productInfoFilterRequest.getLimit();
        PageHelper.offsetPage(offset, productInfoFilterRequest.getLimit());
        List<ProductInfoResponse> data = productInfoDao.filterDrugListByUuid(productInfoFilterRequest);
        return data;
    }


    @Override
    public List<ProductInfoResponse> filterUdiList(ProductInfoFilterRequest productInfoFilterRequest) {
        if (productInfoFilterRequest == null) {
            return Collections.emptyList();
        }
        int offset = (productInfoFilterRequest.getPage() - 1) * productInfoFilterRequest.getLimit();
        PageHelper.offsetPage(offset, productInfoFilterRequest.getLimit());
        List<ProductInfoResponse> data = productInfoDao.filterUdiList(productInfoFilterRequest);
        return data;
    }


    @Override
    public boolean insertProductInfo(ProductInfoEntity productInfoEntity) {
        return productInfoDao.insertProductInfo(productInfoEntity);
    }

    @Override
    public boolean updateProductInfo(ProductInfoEntity productInfoEntity) {
        return productInfoDao.updateProductInfo(productInfoEntity);
    }

    @Override
    public boolean updateUseDy(ProductInfoEntity productInfoEntity) {
        return productInfoDao.updateUseDy(productInfoEntity);
    }

    @Override
    public boolean deleteById(String id) {
        return productInfoDao.deleteById(id);
    }

    @Override
    public boolean deleteAll(List<String> ids) {
        return productInfoDao.deleteAll(ids);
    }

    @Override
    public ProductInfoEntity selectById(String id) {
        return productInfoDao.selectById(id);
    }


    @Override
    public List<OrderDetailEntity> findByCodes(List<String> codes) {
        return productInfoDao.findByCodes(codes);
    }

    @Override
    public List<String> findNameCodeByGid(String goodsId) {
        return productInfoDao.findNameCodeByGid(goodsId);
    }

    @Override
    public boolean isExit(String nameCode) {
        String name = productInfoDao.isExit(nameCode);
        if (name == null) {
            return false;
        } else return true;
    }

    @Override
    public ErpDetailCodeEntity getDetailCode(String code) {
        return productInfoDao.getDetailCode(code);
    }

    @Override
    public ErpDetailCodeEntity getDetailCodeNoBh(String code) {
        return productInfoDao.getDetailCodeNoBh(code);
    }
}
