package com.glxp.udi.admin.service.receipts.impl;

import com.github.pagehelper.PageHelper;
import com.glxp.udi.admin.dao.receipt.ProductDao;
import com.glxp.udi.admin.entity.receipt.ProductOrderDetailEntity;
import com.glxp.udi.admin.entity.receipt.ProductOrderEntity;
import com.glxp.udi.admin.req.receipt.AddProductRequest;
import com.glxp.udi.admin.req.receipt.ProductFilterRequest;
import com.glxp.udi.admin.service.receipts.ProductService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;

@Service
public class ProductServiceImpl implements ProductService {

    @Resource
    ProductDao productDao;

    @Override
    public List<ProductOrderDetailEntity> filterList(ProductFilterRequest productFilterRequest) {
        if (productFilterRequest == null) {
            return Collections.emptyList();
        }
        int offset = (productFilterRequest.getPage() - 1) * productFilterRequest.getLimit();
        PageHelper.offsetPage(offset, productFilterRequest.getLimit());
        List<ProductOrderDetailEntity> data = productDao.filterList(productFilterRequest);
        return data;
    }

    @Override
    public List<ProductOrderEntity> filterProductOrder(ProductFilterRequest productFilterRequest) {
        return productDao.filterProductOrder(productFilterRequest);
    }

    @Override
    public boolean insertProduct(AddProductRequest productOrderEntity) {
        return productDao.insertProduct(productOrderEntity);
    }

    @Override
    public boolean addProduct(ProductOrderEntity productOrderEntity) {
        return productDao.addProduct(productOrderEntity);
    }

    @Override
    public boolean insertProductList(List<ProductOrderEntity> productOrderEntities) {
        return productDao.insertProductList(productOrderEntities);
    }


    @Override
    public boolean deleteById(String id) {
        return productDao.deleteById(id);
    }

    @Override
    public boolean updateProduct(ProductOrderEntity productOrderEntity) {
        return productDao.updateProduct(productOrderEntity);
    }

    @Override
    public ProductOrderEntity selectById(String id) {
        return productDao.selectById(id);
    }

    @Override
    public boolean isExit(String OrderNo) {
        String data = productDao.isExit(OrderNo);
        if (data != null)
            return true;
        else
            return false;
    }
}
