package com.glxp.udi.admin.service.receipts.impl;

import com.github.pagehelper.PageHelper;
import com.glxp.udi.admin.dao.receipt.ReceiptDao;
import com.glxp.udi.admin.entity.receipt.ReceiptsEntity;
import com.glxp.udi.admin.req.receipt.ReceiptFilterRequest;
import com.glxp.udi.admin.service.receipts.ReceiptsService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Collections;
import java.util.List;

@Service
public class ReceiptsServiceImpl implements ReceiptsService {


    @Resource
    ReceiptDao receiptDao;

    @Override
    public List<ReceiptsEntity> filterList(ReceiptFilterRequest receiptFilterRequest) {
        if (receiptFilterRequest == null) {
            return Collections.emptyList();
        }
        int offset = (receiptFilterRequest.getPage() - 1) * receiptFilterRequest.getLimit();
        PageHelper.offsetPage(offset, receiptFilterRequest.getLimit());
        List<ReceiptsEntity> data = receiptDao.filterList(receiptFilterRequest);
        return receiptDao.filterList(receiptFilterRequest);
    }

    @Override
    public boolean insertReceipts(List<ReceiptsEntity> receipts) {
        if (receipts == null) {
            return false;
        }
        return receiptDao.insertReceipts(receipts);
    }

    @Override
    public boolean updateReceipts(ReceiptsEntity receiptsEntity) {
        return receiptDao.updateReceipts(receiptsEntity);
    }

    @Override
    public boolean deleteById(String id) {
        return receiptDao.deleteById(id);
    }
}
