package com.glxp.udi.admin.thread;

import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.TypeReference;
import com.glxp.udi.admin.entity.inout.UdiInfoEntity;
import com.glxp.udi.admin.entity.udid.UdiEntity;
import com.glxp.udi.admin.req.inout.FilterUdiInfoRequest;
import com.glxp.udi.admin.res.PageSimpleResponse;
import com.glxp.udi.admin.service.inout.UdiInfoService;
import com.glxp.udi.admin.util.FilterUdiUtils;
import com.glxp.udi.admin.util.HttpClient;
import com.glxp.udi.common.res.BaseResponse;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.scheduling.annotation.Async;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Service
public class BasicUpdateProductService {

    @Value("${UDI_SERVER_URL}")
    private String udiUrl;
    @Resource
    UdiInfoService udiInfoService;


    @Async
    public void relAllUdi(FilterUdiInfoRequest productInfoFilterRequest) {
        int page = 1;
        int limit = 100;
        while (true) {
            productInfoFilterRequest.setPage(page);
            productInfoFilterRequest.setLimit(limit);
            List<UdiInfoEntity> udiInfoEntities = getUdiInfoEntity(productInfoFilterRequest);
            if (udiInfoEntities != null && udiInfoEntities.size() > 0) {
                for(UdiInfoEntity udiInfoEntity:udiInfoEntities){
                    udiInfoEntity.setCustomerId(productInfoFilterRequest.getCustomerId());
                }
                udiInfoService.insertUdiInfos(udiInfoEntities);
                if (udiInfoEntities.size() < limit) {
                    break;
                } else {
                    page++;
                }
            } else {
                break;
            }

        }


    }


    public List<UdiInfoEntity> getUdiInfoEntity(FilterUdiInfoRequest productInfoFilterRequest) {
        String nameCode = null;
        if (productInfoFilterRequest.getNameCode() != null) {
            UdiEntity udiEntity = FilterUdiUtils.getUdi(productInfoFilterRequest.getNameCode());
            if (udiEntity != null) {
                nameCode = udiEntity.getUdi();
            } else {
                nameCode = productInfoFilterRequest.getNameCode();
            }
        }
        Map<String, Object> paramMap = new HashMap<>(16);
        paramMap.put("page", productInfoFilterRequest.getPage());
        paramMap.put("limit", productInfoFilterRequest.getLimit());
        paramMap.put("ylqxzcrbarmc", productInfoFilterRequest.getYlqxzcrbarmc());
        paramMap.put("cpmctymc", productInfoFilterRequest.getCpmctymc());
        paramMap.put("nameCode", nameCode);
        paramMap.put("ggxh", productInfoFilterRequest.getGgxh());
        paramMap.put("zczbhhzbapzbh", productInfoFilterRequest.getZczbhhzbapzbh());
        paramMap.put("uuid", productInfoFilterRequest.getUuid());

        String response = HttpClient.mipsGet(udiUrl + "/udidl/device/filterUdi", paramMap);
        try {

            BaseResponse<PageSimpleResponse<UdiInfoEntity>> udiDlDeviceResponse =
                    JSONObject.parseObject(response, new TypeReference<BaseResponse<PageSimpleResponse<UdiInfoEntity>>>() {

                    });
            if (udiDlDeviceResponse != null) {
                List<UdiInfoEntity> udiInfoEntities = udiDlDeviceResponse.getData().getList();
                return udiInfoEntities;
            }
        } catch (Exception e) {
            e.printStackTrace();
            return null;
        }
        return null;
    }
}
