package com.glxp.udi.admin.util;


import com.glxp.udi.admin.entity.inout.UdiInfoEntity;
import com.glxp.udi.admin.entity.udid.UdiEntity;

/**
 * @author 彭于晏
 * @date 2020/9/22.
 */
public class FilterUdiUtils {
    private static final String TAG = "FilterUdiUtils";

    public static UdiEntity getUdi(String data) {
        if (data != null && data.length() > 2) {
            if (data.substring(0, 2).equals("MA")) {
                return getZGCUdi(data);
            } else if (data.substring(0, 2).equals("01")) {
                return getGS1Udi(data);
            } else if (data.substring(0, 1).equals("#")) {
                return getGLXPUdi(data);
            }
        }
        return null;
    }

    public static UdiEntity getGS1Udi(String data) {
        String batchNo = "";
        String produceDate = "";
        String expireDate = "";
        String serialNo = null;
        String udi = "";
        UdiEntity udiEntity = null;
        if (data.length() >= 16) {
            udi = data.substring(2, 16);
            if (data.length() >= 18 && data.substring(16, 18).equals("10")) {
                if (data.contains("\u001D")) {
                    String[] splits = data.split("\u001D");
                    String front = splits[0];
                    batchNo = front.substring(18, front.length());
                    String last = splits[1];
                    boolean b = last.length() >= 18 && last.substring(16, 18).equals("21");
                    if ((last != null && last.length() >= 2) && last.substring(0, 2).equals("11")) {
                        produceDate = last.substring(2, 8);
                        if (last.length() >= 10 && last.substring(8, 10).equals("17")) {
                            expireDate = last.substring(10, 16);
                            if (b) {
                                serialNo = last.substring(18, last.length());
                            } else {
                                serialNo = null;
                            }
                        }
                    } else if ((last != null && last.length() >= 2) && last.substring(0, 2).equals("17")) {
                        expireDate = last.substring(2, 8);
                        if (last.length() >= 10 && last.substring(8, 10).equals("11")) {
                            produceDate = last.substring(10, 16);
                            if (b) {
                                serialNo = last.substring(18, last.length());
                            } else {
                                serialNo = null;
                            }
                        }
                    } else if ((last != null && last.length() >= 2) && last.substring(0, 2).equals("21")) {
                        serialNo = last.substring(2, last.length());
                    }
                } else {
                    batchNo = data.substring(18);
                }


            } else if (data.length() >= 18 && data.substring(16, 18).equals("11")) {
                produceDate = data.substring(18, 24);
                if (data.length() >= 26 && data.substring(24, 26).equals("17")) {
                    expireDate = data.substring(26, 32);
                    if (data.length() >= 34 && data.substring(32, 34).equals("10")) {
                        if (data.contains("\u001D")) {
                            String[] splits = data.split("\u001D");
                            batchNo = splits[0].substring(34, splits[0].length());
                            serialNo = splits[1].substring(2);
                        } else {
                            batchNo = data.substring(34, data.length());
                        }

                    }
                } else if (data.length() >= 26 && data.substring(24, 26).equals("10")) {
                    if (data.contains("\u001D")) {
                        String[] splits = data.split("\u001D");
                        batchNo = splits[0].substring(26, splits[0].length());
                        String last = splits[1];
                        if (last.substring(0, 2).equals("17")) {
                            expireDate = last.substring(2, 8);
                            if (last.length() >= 10) {
                                serialNo = last.substring(10, last.length());
                            }
                        } else if (last.substring(0, 2).equals("21")) {
                            serialNo = last.substring(2, last.length());
                        }
                    } else {
                        batchNo = data.substring(26, data.length());
                    }

                } else if (data.length() >= 26 && data.substring(24, 26).equals("21")) {

                    serialNo = data.substring(26);
                }
            } else if (data.length() >= 18 && data.substring(16, 18).equals("17")) {
                expireDate = data.substring(18, 24);
                if (data.length() >= 26 && data.substring(24, 26).equals("11")) {
                    produceDate = data.substring(26, 32);
                    if (data.length() >= 34 && data.substring(32, 34).equals("10")) {
                        if (data.contains("\u001D")) {
                            String[] splits = data.split("\u001D");
                            batchNo = splits[0].substring(34, splits[0].length());
                            serialNo = splits[1].substring(2);
                        } else {
                            batchNo = data.substring(34, data.length());
                        }

                    }
                } else if (data.length() >= 26 && data.substring(24, 26).equals("10")) {
                    if (data.contains("\u001D")) {
                        String[] splits = data.split("\u001D");
                        batchNo = splits[0].substring(26);
                        String last = splits[1];
                        if (last.substring(0, 2).equals("11")) {
                            produceDate = last.substring(2, 8);
                            if (last.length() > 8 && last.substring(8, 10).equals("21")) {
                                serialNo = last.substring(10);
                            }
                        } else if (last.substring(0, 2).equals("21")) {
                            serialNo = last.substring(2);
                        }
                    } else {
                        batchNo = data.substring(26, data.length());
                    }
                } else if (data.length() >= 26 && data.substring(24, 26).equals("21")) {

                    serialNo = data.substring(26);
                }

            } else if (data.length() >= 18 && data.substring(16, 18).equals("21")) {
                serialNo = data.substring(18);
            }
            udiEntity = new UdiEntity();
            udiEntity.setUdi(udi);
            udiEntity.setBatchNo(batchNo);
            udiEntity.setExpireDate(expireDate);
            udiEntity.setProduceDate(produceDate);
            udiEntity.setSerialNo(serialNo);
        }
        return udiEntity;
    }

    public static UdiEntity getZGCUdi(String data) {
        String batchNo = "";
        String produceDate = "";
        String expireDate = "";
        String serialNo = null;
        String udi = data;
        String[] spilts = data.split("[.]");
        if (spilts != null && spilts.length >= 5) {
            for (int i = 0; i < 5; i++) {
                udi = udi + "." + spilts[i];
            }
            udi = udi.substring(1);
            for (int i = 0; i < spilts.length; i++) {
                String tempStr = spilts[i];
                if (tempStr != null && tempStr.length() > 1 && tempStr.substring(0, 1).equals("P")) {
                    produceDate = tempStr.substring(1);
                } else if (tempStr != null && tempStr.length() > 1 && tempStr.substring(0, 1).equals("L")) {
                    batchNo = tempStr.substring(1);
                } else if (tempStr != null && tempStr.length() > 1 && tempStr.substring(0, 1).equals("E")) {
                    expireDate = tempStr.substring(1);
                } else if (tempStr != null && tempStr.length() > 1 && tempStr.substring(0, 1).equals("S")) {
                    serialNo = tempStr.substring(1);
                }
            }
        }

        UdiEntity udiEntity = new UdiEntity();
        udiEntity.setBatchNo(batchNo);
        udiEntity.setExpireDate(expireDate);
        udiEntity.setProduceDate(produceDate);
        udiEntity.setUdi(udi);
        udiEntity.setSerialNo(serialNo);
        return udiEntity;

    }

    public static UdiEntity getGLXPUdi(String data) {
        String batchNo = "";
        String produceDate = "";
        String expireDate = "";
        String serialNo = null;
        String udi = "";
        String[] spilts = data.split("#");
        if (spilts != null && spilts.length >= 5) {
            udi = spilts[1];
            produceDate = spilts[2];
            expireDate = spilts[3];
            batchNo = spilts[4];
            if (spilts.length > 6) {
                serialNo = spilts[5];
                if (serialNo != null && serialNo.equals("")) {
                    serialNo = null;
                }
            }

        }
        UdiEntity udiEntity = new UdiEntity();
        udiEntity.setBatchNo(batchNo);
        udiEntity.setExpireDate(expireDate);
        udiEntity.setProduceDate(produceDate);
        udiEntity.setUdi(udi);
        udiEntity.setSerialNo(serialNo);
        return udiEntity;
    }

    public static String getDiStr(String data) {
        String prefix = "";
        if (data != null && data.length() > 2) {
            if (data.substring(0, 2).equals("MA")) {
                String[] spilts = data.split("[.]");
                if (spilts != null && spilts.length >= 5) {
                    for (int i = 0; i < 5; i++) {
                        prefix = prefix + "." + spilts[i];
                    }
                    prefix = prefix.substring(1);
                }
            } else if (data.substring(0, 2).equals("01") && data.length() >= 16) {
                prefix = data.substring(2, 16);
            } else if (data.substring(0, 1).equals("#")) {
                String[] spilts = data.split("#");
                if (spilts != null && spilts.length >= 1)
                    prefix = spilts[1];
            }
        }
        if (prefix.equals(""))
            return data;
        return prefix;
    }


    public static UdiInfoEntity transUdi(UdiInfoEntity data) {
        UdiEntity udiEntity = getUdi(data.getCode());
        if (udiEntity != null) {
            data.setBatchNo(udiEntity.getBatchNo());
            data.setProduceDate(udiEntity.getProduceDate());
            data.setExpireDate(udiEntity.getExpireDate());
            data.setSerialNo(udiEntity.getSerialNo());
        }
        return data;
    }

}
