package com.glxp.udi.admin.util;

import com.glxp.udi.BaseApiAdminApplicationTest;
import com.glxp.udi.admin.entity.inout.AddScanBean;
import com.glxp.udi.admin.entity.inout.AddScanCodeBean;
import com.glxp.udi.admin.req.inout.AddScanRequest;
import io.jsonwebtoken.Claims;
import org.junit.Test;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import static org.junit.Assert.assertNotNull;

public class JwtUtilsTest  extends BaseApiAdminApplicationTest {
    @Test
    public void createToken() {
        Map<String, Object> claims = new HashMap<>();
        claims.put("admin_id", 12222222);
        String token = JwtUtils.createToken(claims, 86400L);
        System.out.println(token);
        System.out.println(token.length());
        assertNotNull(token);
    }

    @Test
    public void createToken1() {
        Map<String, Object> claims = new HashMap<>();
        String token = JwtUtils.createToken(claims);
        System.out.println(token);
        assertNotNull(token);
    }

    @Test
    public void parse() {
        Map<String, Object> claims = new HashMap<>();
        claims.put("admin_id", 1);
        String token = JwtUtils.createToken(claims, 1000L);
        System.out.println(token);
        System.out.println(token.length());
        Claims claim = JwtUtils.parse(token);
        System.out.println(claim);
        assertNotNull(claim);
        System.out.println(claim.get("admin_id"));
    }


    @Test
    public void JSONTest() {
        AddScanRequest addScanRequest = new AddScanRequest();
        AddScanBean addScanBean = new AddScanBean();
        List<AddScanBean> addScanBeanList = new ArrayList<>();

        addScanBean.setAction("SalesWareHouseOut");
        addScanBean.setCorpOrderId("202009181363543");

        AddScanCodeBean addScanCodeBean = new AddScanCodeBean();
        addScanCodeBean.setActDate("2020-11-01");
        addScanCodeBean.setCode("81621820017198831977");
        addScanCodeBean.setOddCount(2);

        List<AddScanCodeBean>  addScanCodeBeans = new ArrayList<>();
        addScanCodeBeans.add(addScanCodeBean);
        addScanBean.setCodes(addScanCodeBeans);

        addScanBeanList.add(addScanBean);
        addScanRequest.setScanDatas(addScanBeanList);
        String data = FastJsonUtils.getBeanToJson(addScanRequest);


//        CodeContrastEntity codeContrastEntity = new CodeContrastEntity();
//        codeContrastEntity.setDrugCode("8102961");
//        codeContrastEntity.setSaleCode("892389237289389");
//        codeContrastEntity.setIsOldSale(0);
//        List<CodeContrastEntity> codeContrastEntities = new ArrayList<>();
//        codeContrastEntities.add(codeContrastEntity);
//        CodeContrastRequest codeContrastRequest = new CodeContrastRequest();
//        codeContrastRequest.setCodeContrastData(codeContrastEntities);
//        String data = FastJsonUtils.getBeanToJson(codeContrastRequest);
        System.out.println(data);
    }

    @Test
    public void getCount(){
        int count = Integer.parseInt("4");

        int max = (int) Math.pow(10, count);
        String serNum;
        for (int i = 1; i < max; i++) {
            serNum = String.format("%0" + count + "d", i);
            System.out.println(serNum);
        }
    }
}
