package com.glxp.udi.admin.util;

import com.glxp.udi.BaseApiAdminApplicationTest;
import com.glxp.udi.admin.entity.inout.WarehouseEntity;
import com.glxp.udi.admin.entity.inout.WarehousetempEntity;
import com.glxp.udi.admin.mongo.service.WarehouseMdService;
import com.glxp.udi.admin.mongo.service.WarehouseTempMdService;
import com.glxp.udi.admin.mongo.utils.PageResult;
import com.glxp.udi.admin.req.inout.WarehouseQueryRequest;
import org.junit.Test;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

public class MongoDbTest extends BaseApiAdminApplicationTest {

    @Resource
    private WarehouseTempMdService warehousetempService;
    @Resource
    private WarehouseMdService warehouseMdService;


    private static final Logger log = LoggerFactory.getLogger(MongoDbTest.class);

    @Test
    public void insertTempWarehouses() {
        List<WarehouseEntity> warehousetempEntityList = new ArrayList<>();
        for (int i = 0; i < 100; i++) {
            WarehouseEntity warehousetempEntity = new WarehouseEntity();
            warehousetempEntity.setAction("1");
            warehousetempEntity.setMainAction("1");
            warehousetempEntity.setCode("1");
            warehousetempEntity.setCorpOrderId("1");
            warehousetempEntity.setActor("1");
            warehousetempEntity.setActDate("1");
            warehousetempEntity.setWrongCode(1);
            warehousetempEntity.setUpperCorpOrderId("1");
            warehousetempEntity.setFromCorpId("1");
            warehousetempEntity.setFromCorp("1");
            warehousetempEntity.setOrderId("1");
            warehousetempEntity.setBatchNo("1");
            warehousetempEntity.setProduceDate("1");
            warehousetempEntity.setExpireDate("1");
            warehousetempEntity.setSerialNo("1");
            warehousetempEntity.setUdi("1");
            warehousetempEntity.setType(1);
            warehousetempEntity.setCount(1);
            warehousetempEntity.setCustomerId(1l);
            warehousetempEntityList.add(warehousetempEntity);
        }

        warehouseMdService.insertWarehouses(warehousetempEntityList);

    }

    @Test
    public void deleteTempWarehouses() {
        Set<String> ids = new HashSet<>();
        ids.add("60d482458f9da70e386e9ef6");
        ids.add("60d482f38f9da74c98219d2e");
//        warehousetempService.deleteTempWarehouses(ids);
    }

    @Test
    public void findTempByOrderId() {
        List<WarehousetempEntity> warehousetempEntities = warehousetempService.findTempByOrderId("60d536408f9da749342ea53a");
        log.info(warehousetempEntities.size() + "");
    }


    @Test
    public void filterWarehouseByPage() {
        WarehouseQueryRequest warehouseQueryRequest = new WarehouseQueryRequest();
        warehouseQueryRequest.setCustomerId(110l);
        warehouseQueryRequest.setOrderId("10");
        warehouseQueryRequest.setPage(1);
        warehouseQueryRequest.setLimit(10);
        PageResult<WarehouseEntity> warehouseEntityPageResult = warehouseMdService.filterWarehouseByPage(warehouseQueryRequest);
        List<WarehouseEntity> warehouseEntities = warehouseMdService.filterWarehouse(warehouseQueryRequest);
        log.info(warehouseEntityPageResult.getTotal() + "");
    }

    @Test
    public void updateWarehouse() {
        warehouseMdService.updateUnit("110","123456","厦门片仔癀");
    }
}
